<?php
/**
 * Prevent direct access to this file
 */
add_action( 'wp_enqueue_scripts', 'themesflat_portfolios_scripts' );

/**
  * Load the scripts
*/
function themesflat_portfolios_scripts() {  
    wp_enqueue_script( 'themesflat-isotope', plugin_dir_url( __FILE__ ) . '/lib/js/isotope.min.js', array('jquery'), true );
    wp_enqueue_script( 'imagesloaded');
}

add_action('init', 'themesflat_register_portfolio_post_type');
add_action( 'customize_register', 'themesflat_customize_slug' );
function themesflat_customize_slug($wp_customize) {
    $wp_customize->add_section(
        'themesflat_slug',
        array(
            'title'         => esc_html('Slug Custom Post', 'specal'),
            'priority'      => 5,
            'sanitize_callback' => 'themesflat_sanitize_text',
        )
    ); 

    // slugs
    $wp_customize->add_setting(
      'faq_slug',
      array(
        'sanitize_callback' => 'esc_attr',
        'default' => 'faq',     
      )   
    );

    $wp_customize->add_control( 
        'faq_slug',
        array(
            'type' => 'text',
            'label' => esc_html('Slug FAQ', 'specal'),
            'section' => 'themesflat_slug',
            'priority' => 1,
        )
    );   
      // slugs
    $wp_customize->add_setting(
      'portfolios_slug',
      array(
        'sanitize_callback' => 'esc_attr',
        'default' => 'portfolios',     
      )   
    );

    $wp_customize->add_control( 
        'portfolios_slug',
        array(
            'type' => 'text',
            'label' => esc_html('Slug Portfolios', 'specal'),
            'section' => 'themesflat_slug',
            'priority' => 2,
        )
    );         
}

/**
  * Register Portfolios post type
*/
function themesflat_register_portfolio_post_type() {
    $labels = array(
        'name'                  => esc_html__( 'Portfolios', 'specal' ),
        'singular_name'         => esc_html__( 'Portfolios', 'specal' ),
        'rewrite'               => array( 'slug' => esc_html__( 'portfolios', 'specal' ) ),
        'menu_name'             => esc_html__( 'Portfolios', 'specal' ),
        'add_new'               => esc_html__( 'New Portfolios', 'specal' ),
        'add_new_item'          => esc_html__( 'Add New Portfolios', 'specal' ),
        'new_item'              => esc_html__( 'New Portfolios Item', 'specal' ),
        'edit_item'             => esc_html__( 'Edit Portfolios Item', 'specal' ),
        'view_item'             => esc_html__( 'View Portfolios', 'specal' ),
        'all_items'             => esc_html__( 'All Portfolios', 'specal' ),
        'search_items'          => esc_html__( 'Search Portfolios', 'specal' ),
        'not_found'             => esc_html__( 'No Portfolios Items Found', 'specal' ),
        'not_found_in_trash'    => esc_html__( 'No Portfolios Items Found In Trash', 'specal' ),
        'parent_item_colon'     => esc_html__( 'Parent Portfolios:', 'specal' ),
        'not_found'             => esc_html__( 'No portfolios found', 'specal' ),
        'not_found_in_trash'    => esc_html__( 'No portfolios found in Trash', 'specal' )
    );
    $args = array(
        'labels'      => $labels,
        'supports'    => array( 'title', 'editor', 'thumbnail', 'custom-fields' ),
        'public'      => true,
        'has_archive' => true,
        'rewrite'     => array('slug' => get_theme_mod('portfolios_slug','portfolios')),
        'menu_icon'   => 'dashicons-format-gallery',
    );
    register_post_type( 'portfolios', $args );
    $labels = array(
        'name'                  => esc_html__( 'Testimonial', 'specal' ),
        'singular_name'         => esc_html__( 'Testimonial', 'specal' ),
        'rewrite'               => array( 'slug' => esc_html__( 'testimonial', 'specal' ) ),
        'menu_name'             => esc_html__( 'Testimonial', 'specal' ),
        'add_new'               => esc_html__( 'New Testimonial', 'specal' ),
        'add_new_item'          => esc_html__( 'Add New Testimonial', 'specal' ),
        'new_item'              => esc_html__( 'New Testimonial Item', 'specal' ),
        'edit_item'             => esc_html__( 'Edit Testimonial Item', 'specal' ),
        'view_item'             => esc_html__( 'View Testimonial', 'specal' ),
        'all_items'             => esc_html__( 'All Testimonial', 'specal' ),
        'search_items'          => esc_html__( 'Search Testimonial', 'specal' ),
        'not_found'             => esc_html__( 'No Testimonial Items Found', 'specal' ),
        'not_found_in_trash'    => esc_html__( 'No Testimonial Items Found In Trash', 'specal' ),
        'parent_item_colon'     => esc_html__( 'Parent Testimonial:', 'specal' ),
        'not_found'             => esc_html__( 'No Testimonial found', 'specal' ),
        'not_found_in_trash'    => esc_html__( 'No Testimonial found in Trash', 'specal' )

    );
    $args = array(
        'labels'      => $labels,
        'supports'    => array( 'title', 'editor', 'thumbnail' ),
        'public'      => true,
        'has_archive' => false,
        'menu_icon'   => 'dashicons-format-quote',
    );
    register_post_type( 'testimonial', $args );
    $labels = array(
        'name'                  => esc_html__( 'FAQ', 'specal' ),
        'singular_name'         => esc_html__( 'FAQ', 'specal' ),
        'rewrite'               => array( 'slug' => esc_html__( 'faq', 'specal' ) ),
        'menu_name'             => esc_html__( 'FAQ', 'specal' ),
        'add_new'               => esc_html__( 'New FAQ', 'specal' ),
        'add_new_item'          => esc_html__( 'Add New FAQ', 'specal' ),
        'new_item'              => esc_html__( 'New FAQ Item', 'specal' ),
        'edit_item'             => esc_html__( 'Edit FAQ Item', 'specal' ),
        'view_item'             => esc_html__( 'View FAQ', 'specal' ),
        'all_items'             => esc_html__( 'All FAQ', 'specal' ),
        'search_items'          => esc_html__( 'Search FAQ', 'specal' ),
        'not_found'             => esc_html__( 'No FAQ Items Found', 'specal' ),
        'not_found_in_trash'    => esc_html__( 'No FAQ Items Found In Trash', 'specal' ),
        'parent_item_colon'     => esc_html__( 'Parent FAQ:', 'specal' ),
        'not_found'             => esc_html__( 'No FAQ found', 'specal' ),
        'not_found_in_trash'    => esc_html__( 'No FAQ found in Trash', 'specal' )

    );
    $args = array(
        'labels'      => $labels,
        'supports'    => array( 'title', 'editor', 'thumbnail','post-formats' ),
        'public'      => true,
        'has_archive' => false,
        'rewrite'      => array('slug' => get_theme_mod('faq_slug','faq')),
        'menu_icon'   => 'dashicons-testimonial',
    );
    register_post_type( 'faq', $args );

    flush_rewrite_rules();
}

add_filter( 'post_updated_messages', 'themesflat_portfolios_updated_messages' );

/**
  * Portfolios update messages.
*/
function themesflat_portfolios_updated_messages ( $messages ) {
    Global $post, $post_ID;
    $messages[esc_html__( 'portfolios', 'specal' )] = array(
        0  => '',
        1  => sprintf( esc_html__( 'Portfolios Updated. <a href="%s">View portfolios</a>', 'specal' ), esc_url( get_permalink( $post_ID ) ) ),
        2  => esc_html__( 'Custom Field Updated.', 'specal' ),
        3  => esc_html__( 'Custom Field Deleted.', 'specal' ),
        4  => esc_html__( 'Portfolios Updated.', 'specal' ),
        5  => isset( $_GET['revision']) ? sprintf( esc_html__( 'Portfolios Restored To Revision From %s', 'specal' ), wp_post_revision_title((int)$_GET['revision'], false)) : false,
        6  => sprintf( esc_html__( 'Portfolios Published. <a href="%s">View Portfolios</a>', 'specal' ), esc_url( get_permalink( $post_ID ) ) ),
        7  => esc_html__( 'Portfolios Saved.', 'specal' ),
        8  => sprintf( esc_html__('Portfolios Submitted. <a target="_blank" href="%s">Preview Portfolios</a>', 'specal' ), esc_url( add_query_arg( 'preview', 'true', get_permalink( $post_ID ) ) ) ),
        9  => sprintf( esc_html__( 'Portfolios Scheduled For: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview Portfolios</a>', 'specal' ),date_i18n( esc_html__( 'M j, Y @ G:i', 'specal' ), strtotime( $post->post_date ) ), esc_url( get_permalink( $post_ID ) ) ),
        10 => sprintf( esc_html__( 'Portfolios Draft Updated. <a target="_blank" href="%s">Preview Portfolios</a>', 'specal' ), esc_url( add_query_arg( 'preview', 'true', get_permalink( $post_ID ) ) ) ),
    );
    return $messages;
}

add_action( 'init', 'themesflat_register_portfolios_taxonomy' );

/**
  * Register portfolios taxonomy
*/
function themesflat_register_portfolios_taxonomy() {
    $labels = array(
        'name'                       => esc_html__( 'Categories', 'specal' ),
        'singular_name'              => esc_html__( 'Categories', 'specal' ),
        'search_items'               => esc_html__( 'Search Categories', 'specal' ),
        'menu_name'                  => esc_html__( 'Categories', 'specal' ),
        'all_items'                  => esc_html__( 'All Categories', 'specal' ),
        'parent_item'                => esc_html__( 'Parent Categories', 'specal' ),
        'parent_item_colon'          => esc_html__( 'Parent Categories:', 'specal' ),
        'new_item_name'              => esc_html__( 'New Categories Name', 'specal' ),
        'add_new_item'               => esc_html__( 'Add New Categories', 'specal' ),
        'edit_item'                  => esc_html__( 'Edit Categories', 'specal' ),
        'update_item'                => esc_html__( 'Update Categories', 'specal' ),
        'add_or_remove_items'        => esc_html__( 'Add or remove Categories', 'specal' ),
        'choose_from_most_used'      => esc_html__( 'Choose from the most used Categories', 'specal' ),
        'not_found'                  => esc_html__( 'No Categories found.', 'specal' ),
        'menu_name'                  => esc_html__( 'Categories', 'specal' ),
    );
    $args = array(
        'labels'       => $labels,
        'hierarchical' => true,
    );
    register_taxonomy( 'portfolios_category', 'portfolios', $args );
        $labels = array(
        'name'                       => esc_html__( 'Categories', 'specal' ),
        'singular_name'              => esc_html__( 'Categories', 'specal' ),
        'search_items'               => esc_html__( 'Search Categories', 'specal' ),
        'menu_name'                  => esc_html__( 'Categories', 'specal' ),
        'all_items'                  => esc_html__( 'All Categories', 'specal' ),
        'parent_item'                => esc_html__( 'Parent Categories', 'specal' ),
        'parent_item_colon'          => esc_html__( 'Parent Categories:', 'specal' ),
        'new_item_name'              => esc_html__( 'New Categories Name', 'specal' ),
        'add_new_item'               => esc_html__( 'Add New Categories', 'specal' ),
        'edit_item'                  => esc_html__( 'Edit Categories', 'specal' ),
        'update_item'                => esc_html__( 'Update Categories', 'specal' ),
        'add_or_remove_items'        => esc_html__( 'Add or remove Categories', 'specal' ),
        'choose_from_most_used'      => esc_html__( 'Choose from the most used Categories', 'specal' ),
        'not_found'                  => esc_html__( 'No Categories found.', 'specal' ),
        'menu_name'                  => esc_html__( 'Categories', 'specal' ),
    );
    $args = array(
        'labels'       => $labels,
        'hierarchical' => true,
    );
    register_taxonomy( 'faq_category', 'faq', $args );
    flush_rewrite_rules();
}

add_action( 'init', 'themesflat_register_portfolios_tag' );

/**
 * Register tag taxonomy
 */
function themesflat_register_portfolios_tag() {
    $labels = array(
        'name'                       => esc_html__( 'Portfolio Tags', 'specal' ),
        'singular_name'              => esc_html__( 'Portfolio Tags', 'specal' ),
        'search_items'               => esc_html__( 'Search Tags', 'specal' ),        
        'all_items'                  => esc_html__( 'All Tags', 'specal' ),
        'new_item_name'              => esc_html__( 'Add New Tag', 'specal' ),
        'add_new_item'               => esc_html__( 'New Tag Name', 'specal' ),
        'edit_item'                  => esc_html__( 'Edit Tag', 'specal' ),
        'update_item'                => esc_html__( 'Update Tag', 'specal' ),
        'menu_name'                  => esc_html__( 'Tags', 'specal' ),
    );
    $args = array(
        'labels'       => $labels,
        'hierarchical' => true,
    );
    register_taxonomy( 'portfolios_tag', 'portfolios', $args );
    flush_rewrite_rules();
}