<?php
add_shortcode( 'themesflat_maps', 'themesflat_shortcode_maps' );

// Map render
function themesflat_shortcode_maps( $atts, $content = null ) {
	$atts = vc_map_get_attributes( 'themesflat_maps', $atts );
	extract (apply_filters( 'themesflat/shortcode/themesflat_maps_atts',$atts));

	$content = wpb_js_remove_wpautop($content, true); // fix unclosed/unwanted paragraph tags in $content

	$img = "";
	if ( wp_get_attachment_url($image) ) {
		$img = wp_get_attachment_url($image);
	}
	
	wp_enqueue_script('themesflat-google');
	wp_enqueue_script('themesflat-gmap3');

	$return = '<div class="themesflat-maps" data-address="' . esc_attr( $address ) . '" data-height="' . intval($height). '" data-images="' . esc_attr( $img ) . '" data-name="' . esc_attr( $name ) . '">
        <div id="map"></div>
    	</div><!-- /.themesflat-maps -->';
	return $return;
}

if ( function_exists( 'vc_map' ) ) {
	add_action( 'vc_before_init', 'themesflat_shortcode_maps_vc' );

	function themesflat_shortcode_maps_vc() {
		vc_map( array(			
			'name'                    => esc_html__( 'Themesflat: Google Maps', 'specal' ),
			'base'                    => 'themesflat_maps',	
			'icon'        => THEMESFLAT_ICON,		
			'content_element'         => true,			
			'category'                => esc_html__( 'specal', 'specal' ),
			'params'                  => array(	

				array(
					"type" => "textfield",
					"holder" => "h3",
					"heading" => esc_html__("name", 'specal'),
					"param_name" => "name",
					"value" => esc_html__("themesflat map", 'specal'),
					"description" => esc_html__("Name display on map.", 'specal'),
				),	

                array(
					"type" => "textfield",
					"holder" => "h3",
					"heading" => esc_html__("address", 'specal'),
					"param_name" => "address",
					"value" => esc_html__("3 London Rd London SE1 6JZ United Kingdom", 'specal'),
					"description" => esc_html__("Address for map.", 'specal'),
				),

              	array(
					"type" => "attach_image",
					"holder" => "img",
					"heading" => esc_html__("Image", 'specal'),
					"param_name" => "image",
					"value" => '',
					"description" => esc_html__("Choose a image display on map", 'specal')
              	),

              	array(
					"type" => "textfield",
					"holder" => "h3",
					"heading" => esc_html__("height", 'specal'),
					"param_name" => "height",
					"value" => esc_html__("350px", 'specal'),
					"description" => esc_html__("Set height for section map", 'specal'),
				),				
			)
		) );
	}
}