<?php
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	/**
	 * Extended class to integrate testimonial slider with
	 * visual composer
	 */
    class WPBakeryShortCode_themesflat_teammember_slider extends WPBakeryShortCodesContainer {
    }
}

/**
 * Register filter for append custom class name
 * that generated from visual-composer
 */
add_filter( 'themesflat/shortcode/themesflat_teammember_class', 'themesflat_teammember_shortcodes_class', 10, 3 );
add_action( 'vc_before_init', 'themesflat_team_member_shortcode_params' );

add_filter( 'themesflat/shortcode/themesflat_teammember_atts', 'themesflat_teammember_shortcode_atts' );

function themesflat_teammember_shortcodes_class($atts) {
	if (function_exists('vc_shortcode_custom_css_class')) {
		$vcclass = vc_shortcode_custom_css_class( $atts['css'], ' ' );
	}

	$class[] = 'themesflat-team';
	$class[] =$vcclass;	
	$class[] = $atts['class'];
	return $class;
}

function themesflat_teammember_shortcode_atts( $atts ) {
	$icons_params = themesflat_available_icons('icon');
	$atts = array_merge($atts,$icons_params);
	return $atts;
}

function themesflat_team_member_shortcode_params() {
	/**
	 * Map the testimonial slider shortcode
	 */
	vc_map( array(
		'name'                    => esc_html__( 'Themesflat: Team Member Slider', 'specal' ),
		'base'                    => 'themesflat_teammember_slider',
		'as_parent'               => array( 'only' => 'themesflat_member' ), // Use only|except attributes to limit child shortcodes (separate multiple values with comma)
		'icon'        => THEMESFLAT_ICON,
		'content_element'         => true,
		'show_settings_on_create' => false,
		'category'                => esc_html__( 'specal', 'specal' ),
		'params'                  => array(			
			array(
				'type' => 'textfield',
				'heading' => esc_html__( 'Margin', 'specal' ),
				'param_name' => 'margin',
				'value' => '30',
				'description' => esc_html__( 'Margin item for slide', 'specal' )
			),

			array(
				'type' => 'textfield',
				'heading' => esc_html__( 'Slides per view', 'specal' ),
				'param_name' => 'slides_per_view',
				'value' => '4',
				'description' => esc_html__( 'The number of items you want to see on the screen.', 'specal' )
			),

			array(
				'type' => 'checkbox',
				'heading' => esc_html__( 'Slider autoplay', 'specal' ),
				'param_name' => 'autoplay',
				'description' => esc_html__( 'Disable autoplay mode.', 'specal' ),
				'value' => array( esc_html__( 'Yes, please', 'specal' ) => 'yes' )
			),

			array(
				'type' => 'checkbox',
				'heading' => esc_html__( 'Show pagination control', 'specal' ),
				'param_name' => 'show_control',
				'value' => array( esc_html__( 'Yes, please', 'specal' ) => 'yes' )
			),

			array(
				'type' => 'checkbox',
				'heading' => esc_html__( 'Show prev/next buttons', 'specal' ),
				'param_name' => 'show_direction',
				'value' => array( esc_html__( 'Yes, please', 'specal' ) => 'yes' )
			),	

			array(
				'type' => 'textfield',
				'heading' => esc_html__( 'Extra class name', 'specal' ),
				'param_name' => 'class',
				'description' => esc_html__( 'Your custom class', 'specal' )
			),

			array(
				'type' => 'css_editor',
				'param_name' => 'css',
				'group' => esc_html__( 'Design Options', 'specal' )
			)
		),
		'js_view' => 'VcColumnView'
	) );

	/**
	 * Map the member item
	 */
	$icons_params = themesflat_map_icons('icon','Icon for readmore');
	vc_map( array(
		'base'        => 'themesflat_member',
		'name'        => esc_html__( 'Themesflat: Team Member', 'specal' ),
		'icon'        => THEMESFLAT_ICON,
		'category'    => esc_html__( 'specal', 'specal' ),
		'params'      => array_merge(
			array(
				array(
					'type'        => 'textfield',
					'heading'     => esc_html__( 'Name', 'specal' ),
					'param_name'  => 'name'
				),

				array(
					'type'       => 'attach_image',
					'heading'    => esc_html__( 'Image', 'specal' ),
					'param_name' => 'image'
				),

				array(
				'type'       => 'textfield',
				'heading'    => esc_html__( 'Image Size', 'specal' ),
				'description'    => esc_html__( '( Enter your image size Ex: full,medium,small,... Default: 270x339 ). Alternatively enter size in pixels (Example: 200x100 (Width x Height)).', 'specal' ),
				'param_name' => 'image_size',
				'std'		 => '270x339'
			),				

				array(
					'type'             => 'textfield',
					'heading'          => esc_html__( 'Subtitle', 'specal' ),
					'param_name'       => 'subtitle',
				),

				array(
					'type'             => 'textfield',
					'heading'          => esc_html__( 'Position', 'specal' ),
					'param_name'       => 'position',
				),

				array(
					'type'       => 'textarea',
					'heading'    => esc_html__( 'Content', 'specal' ),
					'param_name' => 'content'
				),

				array(
					'type'       => 'textfield',
					'heading'    => esc_html__( 'Phone', 'specal' ),
					'param_name' => 'phone'
				),

				array(
					'type'       => 'textfield',
					'heading'    => esc_html__( 'Email', 'specal' ),
					'param_name' => 'email'
				),

				array(
					'type'       => 'textfield',
					'heading'    => esc_html__( 'Facebook URL', 'specal' ),
					'param_name' => 'facebook'
				),

				array(
					'type'       => 'textfield',
					'heading'    => esc_html__( 'Twitter URL', 'specal' ),
					'param_name' => 'twitter'
				),

				array(
					'type'       => 'textfield',
					'heading'    => esc_html__( 'Pinterest URL', 'specal' ),
					'param_name' => 'pinterest'
				),

				array(
					'type'       => 'textfield',
					'heading'    => esc_html__( 'Instagram URL', 'specal' ),
					'param_name' => 'instagram'
				),

				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Read More Link', 'specal' ),
					'param_name' => 'link',
					'description' => esc_html__( 'Enter custom url for read more button', 'specal' )
				),

				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Read More Text', 'specal' ),
					'param_name' => 'text',
					'description' => esc_html__( 'Enter custom text for read more button', 'specal' ),
					'value' => esc_html__( 'View Profile', 'specal' )
				),
				array(
					'type' => 'checkbox',
					'heading' => esc_html__( 'Show pagination control', 'specal' ),
					'param_name' => 'hide_cotrol',
					'value' => array( esc_html__( 'Yes, please', 'specal' ) => 'yes' )
				)),
			$icons_params,
			array(
				array(
					'type'       => 'textfield',
					'heading'    => esc_html__( 'Extra Class', 'specal' ),
					'param_name' => 'class'
				),

				array(
					'type' => 'css_editor',
					'param_name' => 'css',
					'group' => esc_html__( 'Design Options', 'specal' )
				)
			)
		)
	) );
}

add_shortcode( 'themesflat_member', 'themesflat_shortcode_member' );
add_shortcode( 'themesflat_teammember_slider', 'themesflat_shortcode_teammember_slider' );

/**
 * Testimonial shortcode handle
 * 
 * @param   string  $atts  Shortcode attributes
 * @return  void
 */
function themesflat_shortcode_member( $atts, $content = null ) {
	$atts = vc_map_get_attributes( 'themesflat_member', $atts );
	extract (apply_filters( 'themesflat/shortcode/themesflat_member_atts',$atts));
	$icon_name = themesflat_shortcode_icon_name('icon_',$icon_type);
	$icon_value = !empty($icon_name) ? $atts[$icon_name] : '';

	$member_image = '';
	$member_info ='';
	$class = apply_filters( 'themesflat/shortcode/themesflat_teammember_class',  $atts );
	
	if ( ! empty( $atts['subtitle'] ) || ! empty( $atts['position'] ) )		

	$member_info.= sprintf( '<h4 class="team-name">%s</h4>', wp_kses_post( $atts['name'] ) );
	$member_info.= sprintf( '<div class="team-subtitle">%s</div>', wp_kses_post( $atts['subtitle'] ) );
	$member_info.= sprintf( '<div class="team-position">%s</div>', wp_kses_post( $atts['position'] ) );	
	
	$member_extra_info = '';
	$extra_info = array('phone' => esc_html__('Phone', 'specal'),'email' => esc_html__('Email', 'specal'));
	if ( !empty($phone) || !empty($email) ) {
		$member_extra_info = '<ul class="themesflat_member_extra_info">';
		foreach ($extra_info as $key => $value) {
			if(!empty($atts[$key])) {
				$member_extra_info .= "<li><span>".esc_html($value).":</span>".esc_html__($atts[$key], 'specal')."</li>";
			}
		}
		$member_extra_info .= '</ul>';
	}

	$social_links = '';

	if ( ! empty( $atts['facebook'] ) )
		$social_links.= sprintf( ' <a href="%s" data-title="Facebook" class="facebook"><i class="fa fa-facebook"></i></a>', esc_url( $atts['facebook'] ) );

	if ( ! empty( $atts['twitter'] ) )
		$social_links.= sprintf( ' <a href="%s" data-title="Twitter" class="twitter"><i class="fa fa-twitter"></i></a>', esc_url( $atts['twitter'] ) );

	if ( ! empty( $atts['pinterest'] ) )
		$social_links.= sprintf( ' <a href="%s" data-title="pinterest" class="pinterest"><i class="fa fa-pinterest-p"></i></a>', esc_url( $atts['pinterest'] ) );

	if ( ! empty( $atts['instagram'] ) )
		$social_links.= sprintf( ' <a href="%s" data-title="Instagram" class="instagram"><i class="fa fa-instagram"></i></a>', esc_url( $atts['instagram'] ) );
	$box_readmore = '';	

	if ( ! empty( $atts['link'] ) && ! empty( $atts['text'] ) ) {
		$box_readmore = sprintf( '
				<a class="themesflat-button" href="%1$s">%2$s <i class="%3$s"></i></a>
			', esc_url( $atts['link'] ), esc_html( $atts['text'], 'specal' ),esc_attr($icon_value ));
	}	
	$box_social_links = '';

	if ( ! empty( $social_links ) )
		$social_links = sprintf( '<div class="social-links">%s</div>',$social_links);

		$box_social_links = sprintf( '<div class="box-social-links">%s %s</div>', $social_links,$box_readmore );

	$box_social_links_grid = ('grid' ? $box_social_links : '');

	if ( ! empty( $atts['image'] ) ) {
		if ( is_numeric( $atts['image'] ) && $atts['image'] != '') {
		  	$image = wpb_getImageBySize( array( 'attach_id' => $atts['image'], 'thumb_size' => $atts['image_size'] ) );
		  	$image = $image['thumbnail'];
		}elseif ( filter_var( $atts['image'], FILTER_VALIDATE_URL ) ) {
		  	$image = sprintf( '<img src="%s" />', esc_url( $atts['image'] ) );
		}
				
		$class[] = 'has-image';		
		$member_image = sprintf( '
			<div class="team-image item-hover">
				%s
				<div class="gallery-content">
                    <ul class="gallery-link">
                        <li class="icon-s FromLeft"><a href="tel:'. esc_attr($phone) .'"><span><i class="icon_phone"></i></span></a></li>
                        <li class="icon-l FromRight"><a href="mailto:'.esc_attr($email).'"><span><i class="icon_mail_alt"></i></span></a></li>
                    </ul>
                </div>                
				
			</div>
		', wp_kses_post($image), esc_attr( $atts['name'] ));
	}

	return sprintf( '
		<div class="%s themesflat-hover">
			%s			
			<div class="team-info">	
				%s			
				<div class="team-desc">%s</div>
				%s
				%s
			</div>
		</div>
	', esc_attr( implode( ' ', $class ) ), wp_kses_post($member_image), wp_kses_post($member_info), wp_kses_post($content),wp_kses_post('') ,wp_kses_post($box_social_links_grid)
	 );
}

/**
 * This function will be use to handle testimonial slider
 * shortcode
 * 
 * @param   string  $atts     Shortcode attributes
 * @param   string  $content  Shortcode content
 * @return  string
 */
function themesflat_shortcode_teammember_slider( $atts, $content = null ) {
	
	$atts = vc_map_get_attributes( 'themesflat_teammember_slider', $atts );
	extract (apply_filters( 'themesflat/shortcode/themesflat_teammember_slider_atts',$atts));
	$config = $atts;
	unset( $config['class'] );
	unset( $config['css'] );
	$class = apply_filters( 'themesflat/shortcode/themesflat_testimonial_slider_class', array( 'testimonial-slider','themesflat_enable_slider', $atts['class'] ), $atts );

	// Enqueue shortcode assets
	wp_enqueue_script( 'themesflat-carousel' );
	
	return sprintf( '
		<div class="%s" data-margin="%s" data-slides_per_view="%s" data-autoplay="%s" data-show_control="%s" data-show_direction="%s">			
			%s				
		</div>
	', implode( ' ', $class ), esc_attr( $margin ) , esc_attr( $slides_per_view ), esc_attr( $autoplay ), esc_attr( $atts['show_control'] ), esc_attr( $atts['show_direction'] ),  do_shortcode( $content ) );
}

