<?php
add_filter( 'themesflat/shortcode/faq_atts', 'themesflat_faq_shortcode_atts');

function themesflat_faq_loadmore_text(){
	return esc_html__('VIEW MORE FAQ','specal');
}

function themesflat_faq_shortcode_atts( $atts ) {
	$icons_params = themesflat_available_icons('icon');
	$atts = array_merge($atts,$icons_params);
	return $atts;
}

if ( ! class_exists('themesflat_VCExtend') ) {
	class themesflat_VCExtend {
		function __construct() {
			// We safely integrate with VC with this hook
			add_action( 'init', array( $this, 'integrateWithVC' ) );

			// Use this when creating a shortcode addon
			$shortcodes = 'themesflat_portfolio,themesflat_posts,themesflat_faq';
			$shortcodes = explode(",", $shortcodes);
			$shortcodes = array_map("trim", $shortcodes);
			foreach ( $shortcodes as $shortcode ) {
				add_shortcode($shortcode, array( $this, $shortcode ) );
			} 
		}

		public function integrateWithVC() {
	        // Check if Visual Composer is installed
			if ( ! defined( 'WPB_VC_VERSION' ) ) {
	            // Display notice that Visual Compser is required
				add_action('admin_notices', array( $this, 'showVcVersionNotice' ));
				return;
			}		
			
			//portfolio option
			$category_portfolio = get_terms( 'orderby=name' );
			$category_portfolio_name[] = 'All';
			$category_order = array();
			foreach ( $category_portfolio as $category ) {				
				$category_portfolio_name[$category->name] = $category->slug;
				$category_order[] = $category->slug;		
			}

			$category_order = implode(',', $category_order);			

			vc_map( array(
				'base'        => 'themesflat_portfolio',
				'icon'        => THEMESFLAT_ICON,
				'name'        => esc_html__( 'Themesflat: Portfolio', 'specal' ),
				'category'    => esc_html__( 'specal', 'specal' ),
				'params'      => array(
					array(
						"type"        => "dropdown",
						"heading" => esc_html__("Category", 'specal'),
						"param_name" => "category",
						"value"       => $category_portfolio_name,
						"description" => esc_html__("Display posts from some categories.", 'specal'),
					),	

					array(
						'type'       => 'dropdown',
						'heading'    => esc_html__( 'Style', 'specal' ),
						'param_name' => 'style',
						'value' => array(
							esc_html__( 'Grid 1', 'specal' )           => 'grid',
							esc_html__( 'Grid No Padding', 'specal' )   => 'grid-no-padding',
							)
					),

					array(
						'type'       => 'dropdown',
						'heading'    => esc_html__( 'Grid Columns', 'specal' ),
						'param_name' => 'columns',
						'value'      => array(
							esc_html__( '3 Columns', 'specal' ) => 'one-three',
							esc_html__( '2 Columns', 'specal' ) => 'one-half',							
							esc_html__( '4 Columns', 'specal' ) => 'one-four',
							esc_html__( '5 Columns', 'specal' ) => 'one-five'
							)
					),

					array(
						'type'       => 'textfield',
						'heading'    => esc_html__( 'Image Size', 'specal' ),
						'description'    => esc_html__( '( Enter your image size Ex: full,... Default: Full ). Alternatively enter size in pixels (Example: 200x100 (Width x Height)).', 'specal' ),
						'param_name' => 'image_size',
						'std'		 => 'full'
					),

					array(
						'type'       => 'textfield',
						'heading'    => esc_html__( 'Number Of Items', 'specal' ),
						'param_name' => 'limit',
						'value'      => 9
					),			

					array(
						'type'        => 'textfield',
						'heading'     => esc_html__( 'Exclude', 'specal' ),
						'param_name'  => 'exclude',
						'description' => esc_html__( 'Not Show these portfolios by IDs EX:1,2,3', 'specal' ),
					),	

					array(
						'type' => 'dropdown',
						'heading' => esc_html__( 'Enable Carousel Mode', 'specal' ),
						'param_name' => 'enable_carousel',
						'value' => array(
							esc_html__( 'No', 'specal' ) => 'no',
							esc_html__( 'Yes, please', 'specal' ) => 'yes'							
							)
					),

					array(
						'type' => 'checkbox',
						'heading' => esc_html__( 'Hide title portfolio', 'specal' ),
						'param_name' => 'hide_title',
						'value' => array( esc_html__( 'Yes, please', 'specal' ) => 'yes' ),
					),

					array(
						'type' => 'checkbox',
						'heading' => esc_html__( 'Hide category portfolio', 'specal' ),
						'param_name' => 'hide_category',
						'value' => array( esc_html__( 'Yes, please', 'specal' ) => 'yes' )
					),

					array(
						'type' => 'dropdown',
						'heading' => esc_html__( 'Show Filter', 'specal' ),
						'param_name' => 'show_filter',
						'dependency' => array(
							'element' => 'enable_carousel',
							'value'	=> 'no'
							),
						'value' => array(
							esc_html__( 'No', 'specal' ) => 'no',
							esc_html__( 'Yes, please', 'specal' ) => 'yes'							
							)
					),

					array(
						'type'       => 'textfield',
						'heading'    => esc_html__( 'Categories order', 'specal' ),
						'param_name' => 'cat_order',
						'dependency' => array(
							'element' => 'show_filter',
							'value'	=> 'yes'
							),
						'description'=> 'Categories order split by ","',
						'value'      => $category_order
					),

					array(
						'type'       => 'checkbox',
						'heading'    => esc_html__( 'Show Portfolio Content', 'specal' ),
						'param_name' => 'show_content',
						'value'      => array(
							esc_html__( 'Yes, please', 'specal' ) => 'yes'
							)
					),

					array(
						'type'       => 'textfield',
						'heading'    => esc_html__( 'Portfolio Content Length', 'specal' ),
						'param_name' => 'content_length',
						'value'      => 41
					),

					array(
						'type'       => 'textfield',
						'heading'    => esc_html__( 'Extra Class', 'specal' ),
						'param_name' => 'class'
					),

					array(
						'type' => 'css_editor',
						'param_name' => 'css',
						'group' => esc_html__( 'Design Options', 'specal' )
						)
					)

				));    
			
			/**
			 * Map the post shortcode
			 */
			$category_posts = get_terms( 'category' );
			$category_posts_name[] = 'All';
			foreach ( $category_posts as $category_post ) {
				$category_posts_name[$category_post->name] = $category_post->slug;		
			}

			vc_map( array(
				'name'                    => esc_html__( 'Themesflat: Blog Posts', 'specal' ),
				'base'                    => 'themesflat_posts',
				'icon'        => THEMESFLAT_ICON,
				'category'    => esc_html__( 'specal', 'specal' ),
				'params'                  => array(
					array(
						'type'        => 'textfield',
						'heading'     => esc_html__( 'Widget Title', 'specal' ),
						'param_name'  => 'title',
						'description' => esc_html__( 'Enter text which will be used as widget title. Leave blank if no title is needed.', 'specal' )
					),

					array(
						"type"        => "dropdown",
						"heading" => esc_html__("Category", 'specal'),
						"param_name" => "category_post",
						"value"       => $category_posts_name,
						"description" => esc_html__("Display posts from some categories.", 'specal'),
					),

					array(
						'type'       => 'dropdown',
						'heading'    => esc_html__( 'Layout', 'specal' ),
						'param_name' => 'layout',
						'value'      => array(
							esc_html__( 'List', 'specal' ) => 'blog-list',
							esc_html__( 'List small', 'specal' ) => 'blog-list-small',
							esc_html__( 'Grid', 'specal' ) => 'blog-grid'

							)
					),

					array(
						'type'        => 'dropdown',
						'heading'     => esc_html__( 'Grid Columns', 'specal' ),
						'param_name'  => 'grid_columns',
						'description' => esc_html__( 'The number of columns for grid and grid masonry layout', 'specal' ),
						'dependency' => array(
							'element' => 'layout',
							'value'	=> 'blog-grid'
							),
						'value'       => array(
							esc_html__( '2 Columns', 'specal' ) => 2,
							esc_html__( '3 Columns', 'specal' ) => 3,
							esc_html__( '4 Columns', 'specal' ) => 4
							)
					),

					array(
						'type'        => 'textfield',
						'heading'     => esc_html__( 'Limit', 'specal' ),
						'param_name'  => 'limit',
						'description' => esc_html__( 'The number of posts will be shown', 'specal' ),
						'value'       => 9
					),

					array(
						'type'        => 'textfield',
						'heading'     => esc_html__( 'Post Ids will be inorged. Ex: 1,2,3', 'specal' ),
						'param_name'  => 'exclude',
					),

					array(
						'type'       => 'checkbox',
						'heading'    => esc_html__( 'Hide Post Content', 'specal' ),
						'param_name' => 'hide_content',
						'value'      => array(
							esc_html__( 'Yes, please', 'specal' ) => 'yes'
							)
					),

					array(
						'type'       => 'checkbox',
						'heading'    => esc_html__( 'Enable Carousel', 'specal' ),
						'param_name' => 'blog_carousel',
						'value'      => array(
							esc_html__( 'Yes, please', 'specal' ) => 'yes'
							)
					),

					array(
						'type'       => 'textfield',
						'heading'    => esc_html__( 'Post Content Length', 'specal' ),
						'param_name' => 'content_length',
						'value'      => 150
					),

					array(
						'type'       => 'checkbox',
						'heading'    => esc_html__( 'Hide Read More', 'specal' ),
						'param_name' => 'hide_readmore',
						'value'      => array(
							esc_html__( 'Yes, please', 'specal' ) => 'yes'
							)
					),

					array(
						'type'       => 'textfield',
						'heading'    => esc_html__( 'Read More Text', 'specal' ),
						'param_name' => 'readmore_text',
						'value'      => htmlspecialchars_decode(esc_html__( 'Read More <i class="fa fa-chevron-right" aria-hidden="true"></i>', 'specal' ))
					),

					array(
						'type'        => 'textfield',
						'heading'     => esc_html__( 'Extra class name', 'specal' ),
						'param_name'  => 'class',
						'description' => esc_html__( 'Your custom class', 'specal' )
					),

					array(
						'type'       => 'css_editor',
						'param_name' => 'css',
						'group'      => esc_html__( 'Design Options', 'specal' )
						)
					)
				) );

			//faq option
			$category_faq= get_terms( 'faq_category' );
			$category_faqname[] = 'All';

			foreach ( $category_faq as $category ) {
				$category_faqname[$category->name] = $category->slug;		
			}

			$icons_params = themesflat_map_icons('icon','Icon for readmore');

			vc_map( array(
				'name'                    => esc_html__( 'Themesflat: FAQ', 'specal' ),
				'base'                    => 'themesflat_faq',
				'icon'        => THEMESFLAT_ICON,
				'category'    => esc_html__( 'specal', 'specal' ),
				'params'                  => array_merge(
					array(
						
						array(
							"type"        => "dropdown",
							"heading" => esc_html__("Category", 'specal'),
							"param_name" => "category_post",
							"value"       => $category_faqname,
							"description" => esc_html__("Display posts from some categories.", 'specal'),
						),

						array(
							'type'        => 'dropdown',
							'heading'     => esc_html__( 'Style', 'specal' ),
							'param_name'  => 'faq_style',
							'value'       => array(
								esc_html__( 'Style 1', 'specal' ) => 'style-1',
								esc_html__( 'Style 2', 'specal' ) => 'style-2',
								)
						),
						
						array(
							'type'        => 'textfield',
							'heading'     => esc_html__( 'Limit', 'specal' ),
							'param_name'  => 'limit',
							'description' => esc_html__( 'The number of posts will be shown', 'specal' ),
							'value'       => 9
						),

						array(
							'type'       => 'checkbox',
							'heading'    => esc_html__( 'Hide Post Content', 'specal' ),
							'param_name' => 'hide_title',
							'value'      => array(
								esc_html__( 'Yes, please', 'specal' ) => 'yes'
								)
						),

						array(
							'type'       => 'checkbox',
							'heading'    => esc_html__( 'Hide Post Content', 'specal' ),
							'param_name' => 'hide_content',
							'value'      => array(
								esc_html__( 'Yes, please', 'specal' ) => 'yes'
								)
						),

						array(
							'type'       => 'checkbox',
							'heading'    => esc_html__( 'Show pagination', 'specal' ),
							'param_name' => 'show_pagination',
							'value'      => array(
								esc_html__( 'Yes, please', 'specal' ) => 'yes'
								)
						),

						
						array(
							'type'       => 'textfield',
							'heading'    => esc_html__( 'Post Content Length', 'specal' ),
							'param_name' => 'content_length',
							'value'      => 150
						),

						array(
							'type'       => 'checkbox',
							'heading'    => esc_html__( 'Hide Read More', 'specal' ),
							'param_name' => 'hide_readmore',
							'value'      => array(
								esc_html__( 'Yes, please', 'specal' ) => 'yes'
								)
						),

						array(
							'type'       => 'textfield',
							'heading'    => esc_html__( 'Read More Text', 'specal' ),
							'param_name' => 'readmore_text',
							'value'      => esc_html__( 'Read More', 'specal' )
							)
					), $icons_params,
					array(

						array(
							'type'        => 'textfield',
							'heading'     => esc_html__( 'Extra class name', 'specal' ),
							'param_name'  => 'class',
							'description' => esc_html__( 'Your custom class', 'specal' )
							)
						)
					)
				) );

		}    

		public static function themesflat_faq( $atts, $content = null ) {
			$atts = vc_map_get_attributes( 'themesflat_faq', $atts );
			extract (apply_filters( 'themesflat/shortcode/themesflat_faq_atts',$atts));
			if ( get_query_var('paged') ) {
				$paged = get_query_var('paged');
			} elseif ( get_query_var('page') ) {
				$paged = get_query_var('page');
			} else {
				$paged = 1;
			}    
			global $themesflat_paging_style;
			global $themesflat_paging_for;
			$themesflat_paging_style = 'loadmore';
			$themesflat_paging_for = 'faq';
			$icon_name = themesflat_shortcode_icon_name('icon_',$icon_type);
			$icon_value = !empty($icon_name) ? $atts[$icon_name] : '';
			wp_enqueue_style( 'vc_'.$atts['icon_type'] );

			if ($icon_value != '') {
				$readmore_text = $readmore_text . sprintf('<i class="%s"></i>',esc_attr($icon_value));
			}
			
			$limit = intval( $limit );		
			$terms_slug = wp_list_pluck( get_terms( 'faq_category','orderby=name&hide_empty=0'), 'slug' );   
			$tax =  $terms_slug;

			if ( empty( $atts['enable_carousel'] ) ) $atts['enable_carousel'] = 'no';
			if ( empty( $atts['show_filter'] ) ) $atts['show_filter'] = 'no';
			if ( empty( $atts['hide_content'] ) ) $atts['hide_content'] = 'no';
				$query_args = array(
					'post_type' => 'faq',
					'posts_per_page' => $limit,
					'paged' => $paged,          
					);
				if ($category_post != 'All') {
					$query_args['tax_query'] = array(
						array(
							'taxonomy' => 'faq_category',   
							'field'    => 'slug',                   
							'terms'    => $category_post,
							)
						);
				}
				$query = new WP_Query($query_args);
				$GLOBALS['wp_query']->max_num_pages = $query->max_num_pages; 
				$_class[] = $faq_style;
				$_class[] = $class;

				ob_start();
				?>
				<div class="themesflat-faq-shortcodes grid one-half <?php echo esc_attr(implode(" ",$_class));?>">
					<?php 
					while ( $query->have_posts() ) : $query->the_post();
						printf('<div class="item %s">',esc_attr(get_post_format()));
							echo '<div class="item-inner">';
								global $themesflat_thumbnail;
								$themesflat_thumbnail = 'themesflat-faq';
								get_template_part('tpl/feature-post'); 
								if ($hide_title  != 'yes') {
									printf('<h2 class="faq-title"><a href="%1$s">%2$s</a></h2>',esc_url(get_the_permalink()),esc_html(get_the_title()));
								}
								$layout = ($faq_style == 'style-2' ? 'blog-list' : 'blog-grid');
								if ($atts['hide_content'] != 'yes') {?>
									<div class="entry-content">
										<?php
										$readmore = $atts['hide_readmore'] != 'yes'  ? wp_kses_post( $readmore_text ) : '[...]';
										themesflat_render_post($layout,$readmore,$atts['content_length']);
										?>

									</div>
								<?php }
							echo '</div>';
						echo '</div>';
					endwhile; 
					?>
				</div>
				<?php if ( $atts['show_pagination'] == 'yes') {
					add_filter('themesflat/template/loadmore_text','themesflat_faq_loadmore_text');
					get_template_part('tpl/pagination');
				}
				wp_reset_query();
				?>
		<?php 
			return ob_get_clean();
		}	
		
		// Portfolio render
		public static function themesflat_portfolio( $atts, $content = null ) {
			$atts = vc_map_get_attributes( 'themesflat_portfolio', $atts );
			extract (apply_filters( 'themesflat/shortcode/themesflat_portfolio_atts',$atts));

			if ( empty( $atts['enable_carousel'] ) ) $atts['enable_carousel'] = 'no';
			if ( empty( $atts['show_filter'] ) ) $atts['show_filter'] = 'no';
			if ( empty( $atts['show_content'] ) ) $atts['show_content'] = 'no';

			ob_start();
			$content = wpb_js_remove_wpautop($content, true); // fix unclosed/unwanted paragraph tags in $content
			$limit = intval( $limit );		
			$terms_slug = wp_list_pluck( get_terms( 'portfolios_category','orderby=name&hide_empty=0'), 'slug' );
			$filters =      wp_list_pluck( get_terms( 'portfolios_category','orderby=name&hide_empty=0'), 'name','slug' ); 

			$tax =  $terms_slug;

			if ( $category != 'All' ) {            
				$tax = $category;
			}		

			if ( get_query_var('paged') ) {
				$paged = get_query_var('paged');
			} elseif ( get_query_var('page') ) {
				$paged = get_query_var('page');
			} else {
				$paged = 1;
			} 

			$orderby = themesflat_choose_opt('portfolio_order_by');
        	$order = themesflat_choose_opt('portfolio_order_direction');
			$query_args = array(
				'post_type' => 'portfolios',
				'posts_per_page' => $limit,
				'paged' => $paged,
				'orderby'   => $orderby,
             	'order' => $order,          
				'tax_query' => array(
					array(
						'taxonomy' => 'portfolios_category',   
						'field'    => 'slug',                   
						'terms'    => $tax,
						),
					),
				);

			if ( ! empty( $atts['exclude'] ) ) {
				$exclude = $atts['exclude'];				
				if ( ! is_array( $exclude ) )
					$exclude = explode( ',', $exclude );
					$query_args['post__not_in'] = $exclude;
			}

			$query = new WP_Query( $query_args );
			$GLOBALS['wp_query']->max_num_pages = $query->max_num_pages; 

			if ( ! $query->have_posts() )
				return;

			echo '<div class="themesflat-portfolio clearfix '.$atts['enable_carousel'].'">'; 
			$show_filter_portfolio = '';

			//Build the filter navigation
	        if ( $show_filter == "yes" ) {	   
	        	$show_filter_portfolio = 'show_filter_portfolio';     	
	            $terms = get_terms('portfolios_category','orderby=name&hide_empty=0');            
	            if ( count($terms) > 0 ) { 
	                echo '<ul class="portfolio-filter '.esc_attr( $class ).'"><li class="active"><a data-filter="*" href="#">' . esc_html__( 'All', 'finance' ) . '</a></li>';                
	                foreach ( $terms as $term ) {
	                    $termname = strtolower( $term->name );  
	                    $termname = str_replace(' ', '-', $termname);
	                    echo '<li><a data-filter=".' . esc_attr( $termname ) . '" href="#" title="' . esc_attr( $term->name ) . '">' . esc_html( $term->name ) . '</a></li>';                                  
	                }
	                echo '</ul>'; //portfolio-filter
	            }
	        }
	        
			if (!empty($columns)) {
				if ($columns == 'one-half') {
					$data_item = 2;
				}elseif ($columns == 'one-three') {
					$data_item = 3;
				}elseif ($columns == 'one-four') {
					$data_item = 4;
				}elseif ($columns == 'one-five') {
					$data_item = 5;
				}
			}

			if (!empty($style)) {
				if ($style =='grid') {
					$data_margin = 30;
				}elseif ($style == 'grid-no-padding') {
					$data_margin = 0;
				}
			}

	        echo '<div class="portfolio-container '.esc_attr( $class ).' '.esc_attr( $style ).' '.esc_attr( $columns ).' '.esc_attr( $show_filter_portfolio ).'" data-item="'.esc_attr( $data_item ).'" data-margin="'.esc_attr( $data_margin ).'">';        
	        while ( $query->have_posts() ) : $query->the_post();
	        global $post;
	        $id = $post->ID;
	        $termsArray = get_the_terms( $id, 'portfolios_category' );
	        $termsString = "";

	        if ( $termsArray ) {
	        	foreach ( $termsArray as $term ) {
	        		$itemname = strtolower( $term->slug ); 
	        		$itemname = str_replace( ' ', '-', $itemname );
	        		$termsString .= $itemname.' ';
	        	}
	        }

	        $imgs = array(
	        	'grid' => 'themesflat-case',
	        	'portfolio-gallery' => 'themesflat-case2',
	        	'grid-no-padding' => 'themesflat-case3'
	        	);
	        $img_portfolio = $imgs[$style];

	        if ( has_post_thumbnail() ):

	        echo '<div class="item portfolio-item ' . $termsString . '">';
	        echo '<div class="wrap-border portfolio-wrap">';
	        echo '<div class="featured-post ">';

	        if($image_size != 'full' && $image_size != ''){
			    $image = wpb_getImageBySize( array( 'attach_id' => get_post_thumbnail_id(get_the_ID()), 'thumb_size' => $atts['image_size'] ) );
			    $image = $image['thumbnail'];			   
			    ?>
			    <a href="<?php the_permalink();?>"><?php echo wp_kses_post($image);?></a>
			    <?php
			   }else{
			    	echo '<a><img src="'.themesflat_thumbnail_url( $img_portfolio ).'" alt="'.get_the_title() .'"></a>';	
			   }                                                                   
	        echo '</div>';
	        echo '<div class="portfolio-info">';
	        echo '<div class="portfolio-info-wrap">';	     
	        if ( $hide_title != 'yes' ) {
	        	echo '<div class="portfolio-title"><a title="' . get_the_title() . '" href="' . get_the_permalink() . '">' . get_the_title() . '</a></div>';
	        }

	        if ( $hide_category != 'yes' ) {	
	        	echo '<div class="portfolio-categories">';
	        	echo the_terms( get_the_ID(), 'portfolios_category', 
	        		'', ' / ', '' );                        
	        	echo '</div>';     
	        }

	        echo '</div>';

	        if ( $atts['show_content'] != 'no' ):
	        	?>

	        <div class="entry-content">
	        	<?php
	        	$content = get_the_content();
	        	$content = trim( strip_tags( $content ) );
	        	$length  = intval( '0' . $atts['content_length'] );
	        	$length  = max( $length, 1 );

	        	if ( mb_strlen( $content ) > $length ) {
	        		$content = mb_substr( $content, 0, $length );
	        		$content.= '...';
	        	}

	        	echo wp_kses_post( $content );
	        	?>					

	        </div> 
	    <?php endif;

	    $thumbnail_url = wp_get_attachment_image_src(get_post_thumbnail_id($post->ID), array('220','220'), true );
    	$thumbnail_url = $thumbnail_url[0];

	     echo '<div class="portfolio-info-icon">
            <ul class="portfolio-link">
                <li class="icon"><a class="popup-gallery" href="'. esc_attr($thumbnail_url) .'"><span><i class="fa fa-search"></i></span></a></li>
                <li class="icon"><a href="'. get_the_permalink() .'"><span><i class="fa fa-link"></i></span></a></li>
            </ul>
        </div>' ;

	    echo '</div>';
	    echo '</div>';
	    echo '</div>';

	    endif;
	    endwhile;	
	    wp_reset_postdata();
	    echo "</div>";
	    echo "</div>";
	    $out_put = ob_get_clean();
	    return $out_put;
	}	

	// Blog post render
	public static function themesflat_posts( $atts, $content = null ) {
		$atts = vc_map_get_attributes( 'themesflat_posts', $atts );
		extract (apply_filters( 'themesflat/shortcode/themesflat_posts_atts',$atts));
		ob_start();
			$content = wpb_js_remove_wpautop($content, true); // fix unclosed/unwanted paragraph tags in $content	

			if ( get_query_var('paged') ) {
				$paged = get_query_var('paged');
			} elseif ( get_query_var('page') ) {
				$paged = get_query_var('page');
			} else {
				$paged = 1;
			}     				

			$query_args = array(					
				'post_status'         => 'publish',
				'post_type'           => 'post',
				'paged' => $paged,
				'ignore_sticky_posts' => true,
				);  

			if ( is_numeric( $atts['limit'] ) && $atts['limit'] >= 0 ) {
				$query_args['posts_per_page'] = $atts['limit'];
			}

			if ( ! empty( $atts['exclude'] ) ) {
				$exclude = $atts['exclude'];

				if ( ! is_array( $exclude ) )
					$exclude = explode( ',', $exclude );

				$query_args['post__not_in'] = $exclude;
			}
			
			if ( $atts['category_post'] != 'All' )
				$query_args['category_name'] = $atts['category_post'];

			$query = new WP_Query( $query_args );	
			$GLOBALS['wp_query']->max_num_pages = $query->max_num_pages; 

			$class_names = array(
				1 => 'blog-one-column',
				2 => 'blog-two-columns',
				3 => 'blog-three-columns',
				4 => 'blog-four-columns',
				);		

			if ( ! $query->have_posts() )
				return;

			$class = apply_filters( 'themesflat/shortcode/posts_class', array( 'blog-shortcode', $atts['class'],  $atts['layout'] ), $atts );

			if ( isset( $class_names[$atts['grid_columns']] ) && in_array( $atts['layout'], array( 'blog-grid', 'blog-masonry' ) ) ) {
				$class[] = $class_names[$atts['grid_columns']];
			}

			if ( $atts['hide_content'] != 'yes' ) {
				$class[] = 'has-post-content';
			}	

			if ( $atts['blog_carousel'] == 'yes' ) {
				$class[] = 'has-carousel';
			}

			$imgs = array(
				'blog-list' => 'themesflat-blog',
				'blog-grid' => 'themesflat-blog-grid',
				'blog-list-small' => 'themesflat-blog-listsmall'
				);
			global $themesflat_thumbnail;
			$themesflat_thumbnail = $imgs[$atts['layout']];
			$items = $atts['layout'] == 'blog-grid' ? $atts['grid_columns'] : 1;
			?>
			<?php if ( ! empty( $atts['title'] ) ): ?>
				<h3 class="widget-title"><?php esc_html_e( $atts['title'], 'specal' ) ?></h3>
			<?php endif ?>

			<div class="<?php esc_attr_e( implode( ' ', $class ) ) ?>" data-items ="<?php themesflat_esc_attr($items);?>">				
				<?php while ( $query->have_posts() ) : $query->the_post(); ?>
					<article class="entry format-<?php echo esc_attr(get_post_format()); ?>">
						<div class="entry-border">
							<?php 
							get_template_part('tpl/feature-post'); ?>
							<?php if ($atts['layout'] != 'blog-grid') { ?>
								<div class="entry-meta clearfix">
									<?php themesflat_posted_on_blog_grid();?>
								</div><!-- /.entry-meta -->
							<?php } ?>
							<div class="content-post">
								<h2 class="entry-title"><a href="<?php the_permalink();?>"><?php the_title();?></a></h2>
								<?php $hide_content_class = '';
									if ( $atts['hide_content'] == 'yes' && $atts['hide_readmore'] == 'yes' ) {
										$hide_content_class = 'hide';
									}
								 ?>

								<div class="entry-content <?php echo esc_attr($hide_content_class);?>">
									<?php
									$readmore = $atts['hide_readmore'] != 'yes'  ? wp_kses_post( $atts['readmore_text'] ) : '[...]';
									if ($hide_content != 'yes') {
										themesflat_render_post(themesflat_choose_opt('blog_archive_layout'));
										if ($hide_readmore != 'yes') {			
											echo '<a class="themesflat-button themesflat-blog" href="'.get_the_permalink().'" rel="nofollow">'.$readmore_text.'</a>';										
										}
									}
									?>

								</div>
								
								<?php if ($atts['layout'] == 'blog-grid') { ?>
									<div class="entry-meta clearfix">
										<?php themesflat_posted_on_blog_grid();?>
									</div><!-- /.entry-meta -->
								<?php } ?>
							</div>
						</div>
					</article><!-- /.entry -->
					<?php
					endwhile;
					echo '</div>'; 	
					$out_put = ob_get_clean();
					wp_reset_query();					
					return $out_put;		
					?>
					<?php 				
				}	
			}
		}

// Finally initialize code
new themesflat_VCExtend();