<?php
/**
 * Register filter for append custom class name
 * that generated from visual-composer
 */

/**
 * Register shortcode into Visual Composer
 */
add_action( 'vc_before_init', 'themesflat_title_section_shortcode_params' );

/**
 * Register parameters for iconbox shortcode
 * 
 * @return  void
 */
function themesflat_title_section_shortcode_params() {
	vc_map( array(
		'base'        => 'themesflat_title_section',
		'name'        => esc_html__( 'Themesflat: Title Section', 'specal' ),
		'icon'        => THEMESFLAT_ICON,
		'category'    => esc_html__( 'specal', 'specal' ),
		'params'      => array(
			array(
				'type'        => 'textfield',
				'heading'     => esc_html__( 'Title', 'specal' ),
				'param_name'  => 'title'
			),

			array(
				'type'       => 'textarea_html',
				'heading'    => esc_html__( 'Content', 'specal' ),
				'param_name' => 'content'
			),

			array(
				'type'       => 'dropdown',
				'heading'    => esc_html__( 'Title Element Tag', 'specal' ),
				'param_name' => 'tag',
				'value'      => array(
					'h1' => 'h1',
					'h5' => 'h5',
					'h3' => 'h3',
					'h2' => 'h2',					
					'h4' => 'h4',
					'h6' => 'h6'
					)
			),

			array(
				'type'       => 'dropdown',
				'heading'    => esc_html__( 'Title Align', 'specal' ),
				'param_name' => 'btn_align',
				'value' => array(
					esc_html__( 'Left', 'specal' ) => 'text-left',
					esc_html__( 'Center', 'specal' ) => 'text-center',
					esc_html__( 'Right', 'specal' ) => 'text-right'
					)
			),

			array(
				'type'       => 'textfield',
				'heading'    => esc_html__( 'Extra Class', 'specal' ),
				'param_name' => 'class'
			),

			array(
				'type' => 'css_editor',
				'param_name' => 'css',
				'group' => esc_html__( 'Design Options', 'specal' )
			)
		)
	) );
}

add_shortcode( 'themesflat_title_section', 'themesflat_title_section_shortcode_render' );
add_filter( 'themesflat/shortcode/title_section_class', 'themesflat_title_section_shortcode_class' );

function themesflat_title_section_shortcode_class(  $atts) {
	if (function_exists('vc_shortcode_custom_css_class')) {
		$vcclass = vc_shortcode_custom_css_class( $atts['css'], ' ' );
	}
	$classes[] = 'title-section';
	$classes[] = $atts['class'];
	$classes[] = $atts['btn_align'];
	$classes[] = $vcclass;
	return $classes;
}
// Title section render
function themesflat_title_section_shortcode_render( $atts, $content = null ) {
	$atts = vc_map_get_attributes( 'themesflat_title_section', $atts );
	extract (apply_filters( 'themesflat/shortcode/themesflat_title_section_atts',$atts));
	$class = apply_filters( 'themesflat/shortcode/title_section_class', $atts );
	$content = wpb_js_remove_wpautop($content, true); // fix unclosed/unwanted paragraph tags in $content
	$title_content = '';

	if ( ! empty( $content ) ) {
		$title_content = sprintf( '
			<div class="title-content">
				%s
			</div>', $content );
	}

	return sprintf( '<div class="%1$s ">
		<%4$s class="title">
			%2$s			
		</%4$s>		
		%3$s

	</div>', esc_attr( implode( ' ', $class ) ), wp_kses_post( $title ), $title_content,esc_attr($tag) );
	
}