<?php
/**
 * The header for our theme.
 *
 * Displays all of the <head> section and everything up till <div id="content">
 *
 * @package specal
 */
?><!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="profile" href="http://gmpg.org/xfn/11">
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>">

<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>

<div class="themesflat-boxed">
	<!-- Preloader -->
    <div class="loading-overlay">
        <div class="Loading-Page">
            <h2 class="loader"><?php esc_html_e('Loading','specal'); ?></h2>
        </div>
    </div>

	<?php 
		get_template_part( 'tpl/topbar');
		get_template_part( 'tpl/site-header');
	?>
	<!-- Page Title -->
	<?php get_template_part( 'tpl/page-title'); ?>
	<?php 
	switch (get_post_type()) {
		case 'page':
			$layouts = themesflat_choose_opt('page_layout');
			break;
		case 'post':
			$layouts = themesflat_choose_opt('blog_layout');
			break;
		default:
			$layouts = themesflat_choose_opt('blog_layout');
			break;
	}
	?>
	<div id="content" class="page-wrap <?php echo esc_attr( $layouts ); ?> ">
		<div class="container content-wrapper">
			<div class="row">

			