<?php
/**
 * specal Theme Customizer
 *
 * @package specal
 */

function themesflat_customize_register( $wp_customize ) {
	$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';    
    $wp_customize->get_section( 'header_image' )->transport = 'postMessage'; 
    $wp_customize->get_section( 'header_image' )->priority = '22';  
    $wp_customize->get_section( 'title_tagline' )->priority = '1';
    $wp_customize->get_section( 'title_tagline' )->title = esc_html('General', 'specal');
    $wp_customize->get_section( 'colors' )->title = esc_html('Layout Style', 'specal'); 
    $wp_customize->remove_section( 'header_image' );  
  
    // Heading
    class themesflat_Info extends WP_Customize_Control {
        public $type = 'heading';
        public $label = '';
        public function render_content() {
        ?>
            <h3 class="themesflat-title-control"><?php echo esc_html( $this->label ); ?></h3>
        <?php
        }
    }    

    // Title
    class themesflat_Title_Info extends WP_Customize_Control {
        public $type = 'title';
        public $label = '';
        public function render_content() {
        ?>
            <h4><?php echo esc_html( $this->label ); ?></h4>
        <?php
        }
    }    

    // Desc
    class themesflat_Theme_Info extends WP_Customize_Control {
        public $type = 'info';
        public $label = '';
        public function render_content() {
        ?>
            <h3><?php echo esc_html( $this->label ); ?></h3>
        <?php
        }
    }    

    // Desc
    class themesflat_Desc_Info extends WP_Customize_Control {
        public $type = 'desc';
        public $label = '';
        public function render_content() {
        ?>
            <p class="themesflat-desc-control"><?php echo esc_html( $this->label ); ?></p>
        <?php
        }
    }       

    // General
    $wp_customize->add_setting('themesflat_options[info]', array(
            'type'              => 'info_control',
            'capability'        => 'edit_theme_options',
            'sanitize_callback' => 'esc_attr',            
        )
    );

    // Heading site infomation
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'custom-stie-infomation', array(
        'label' => esc_html('SITE INFORMATION', 'specal'),
        'section' => 'title_tagline',
        'settings' => 'themesflat_options[info]',
        'priority' => 1
        ) )
    );    

    // Desc site infomaton
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_siteinfomation', array(
        'label' => esc_html('This section have basic information of your site, just change it to match with you need.', 'specal'),
        'section' => 'title_tagline',
        'settings' => 'themesflat_options[info]',
        'priority' => 2
        ) )
    );     
    // Socials
    $wp_customize->add_section(
        'themesflat_socials',
        array(
            'title'         => esc_html('Socials', 'specal'),
            'priority'      => 2,
            'sanitize_callback' => 'themesflat_sanitize_text',
        )
    ); 

      // social links
    $wp_customize->add_setting(
      'social_links',
      array(
        'sanitize_callback' => 'esc_attr',
        'default' => themesflat_customize_default_options2('social_links'),     
      )   
    );

    $wp_customize->add_control( new themesflat_SocialIcons($wp_customize,
        'social_links',
        array(
            'type' => 'social-icons',
            'label' => esc_html('Social', 'specal'),
            'section' => 'themesflat_socials',
            'priority' => 1,
        ))
    );      

    // Header
    $wp_customize->add_section(
        'themesflat_header',
        array(
            'title'         => esc_html('Header', 'specal'),
            'priority'      => 2,
        )
    );

    // Heading custom logo
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'custom-logo', array(
        'label' => esc_html('Custom Logo', 'specal'),
        'section' => 'themesflat_header',
        'settings' => 'themesflat_options[info]',
        'priority' => 2
        ) )
    );    

    // Desc custon logo
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_logo', array(
        'label' => esc_html('In this section You can upload your own custom logo, change the way your logo can be displayed', 'specal'),
        'section' => 'themesflat_header',
        'settings' => 'themesflat_options[info]',
        'priority' => 3
        ) )
    );    

    // Logo
    $wp_customize->add_setting(
        'site_logo',
        array(
            'default' => themesflat_customize_default_options2('site_logo'),
            'sanitize_callback' => 'esc_url_raw',
        )
    );    
    $wp_customize->add_control(
        new WP_Customize_Image_Control(
            $wp_customize,
            'site_logo',
            array(
               'label'          => esc_html( 'Upload your logo ', 'specal' ),
               'description'    => esc_html( 'The best size is 99x19px ( If you don\'t display logo please remove it your website display 
                Site Title default in General )', 'specal' ),
               'type'           => 'image',
               'section'        => 'themesflat_header',
               'priority'       => 5,
            )
        )
    );

    // Logo Retina
    $wp_customize->add_setting(
        'site_retina_logo',
        array(
            'default'           => themesflat_customize_default_options2('site_retina_logo'),
            'sanitize_callback' => 'esc_url_raw',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Image_Control(
            $wp_customize,
            'site_retina_logo',
            array(
               'label'          => esc_html( 'Upload your logo retina', 'specal' ),
               'description'    => esc_html( 'The best size is 198x38px', 'specal' ),
               'type'           => 'image',
               'section'        => 'themesflat_header',
               'priority'       => 6,
            )
        )
    );        

    // Logo Margin Top
    $wp_customize->add_setting(
        'logo_top',
        array(
            'default' => themesflat_customize_default_options2('logo_top'),
            'sanitize_callback' => 'themesflat_sanitize_text',
        )
    );
    $wp_customize->add_control(
        'logo_top',
        array(
            'label' => esc_html( 'Margin top (px)', 'specal' ),
            'section' => 'themesflat_header',
            'type' => 'text',
            'priority' => 10
        )
    );   

    // Heading Header Style
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'header_type', array(
        'label' => esc_html('Header Style', 'specal'),
        'section' => 'themesflat_header',
        'settings' => 'themesflat_options[info]',
        'priority' => 11
        ) )
    );   
   
    $wp_customize->add_setting(
        'header_style',
        array(
            'default'           => themesflat_customize_default_options2('header_style'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( new themesflat_RadioImages($wp_customize,
        'header_style',
        array (
            'type'      => 'radio-images',           
            'section'   => 'themesflat_header',
            'priority'  => 12,
            'label'         => esc_html('Click the header style for your website', 'specal'),
            'choices'   => array (
                'header-style1' => array (
                    'tooltip'   => esc_html( 'Header Style 1','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header1.jpg'
                ) ,
                'header-style2'=>  array (
                    'tooltip'   => esc_html( 'Header Style 2','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header2.jpg'
                ) ,
               'header-style3'=>  array(
                    'tooltip'   => esc_html( 'Header Style 3','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header3.jpg'
                ) ,
               'header-style4'=>  array(
                    'tooltip'   => esc_html( 'Header Style 4','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header4.jpg'
                ) ,
               'header-style5'=>  array(
                    'tooltip'   => esc_html( 'Header Style 5','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header5.jpg'
                ) ,
            ),
        ))
    );

    
    // Header Sticky
    $wp_customize->add_setting(
      'header_searchbox',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('header_searchbox'),     
        )   
    );
    $wp_customize->add_control(
        'header_searchbox',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Show search', 'specal'),
            'section' => 'themesflat_header',
            'priority' => 15,
        )
    );  

      // Header Sticky
    $wp_customize->add_setting(
      'header_sticky',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('header_sticky'),     
        )   
    );
    $wp_customize->add_control(
        'header_sticky',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable sticky header', 'specal'),
            'section' => 'themesflat_header',
            'priority' => 16,
        )
    ); 

    // Top enable button header
    $wp_customize->add_setting(
        'enable_button_header',
        array(
            'default' => themesflat_customize_default_options2('enable_button_header'),
            'sanitize_callback' => 'themesflat_sanitize_checkbox'
        )
    );
    $wp_customize->add_control(
        'enable_button_header',
        array(
            'label' => esc_html( 'Enable Header Button', 'specal' ),
            'section' => 'themesflat_header',
            'type' => 'checkbox',
            'priority' => 17
        )
    );
    

    // Top Header Button
    $wp_customize->add_setting(
        'header_button',
        array(
            'default' => themesflat_customize_default_options2('header_button'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'header_button',
        array(
            'label' => esc_html( 'Header Button', 'specal' ),
            'section' => 'themesflat_header',
            'type' => 'textarea',
            'priority' => 18
        )
    );  

    // Heading Top Bar 
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'top-bar', array(
        'label' => esc_html('Top Bar', 'specal'),
        'section' => 'themesflat_header',
        'settings' => 'themesflat_options[info]',
        'priority' => 19
        ) )
    );    

    // Desc Top Bar 
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc', array(
        'label' => esc_html('Turn on/off the top bar and change it styles', 'specal'),
        'section' => 'themesflat_header',
        'settings' => 'themesflat_options[info]',
        'priority' => 20
        ) )
    );  

    // Top bar
    $wp_customize->add_setting(
      'topbar_enabled',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('topbar_enabled'),     
        )   
    );
    $wp_customize->add_control(
        'topbar_enabled',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Topbar', 'specal'),
            'section' => 'themesflat_header',
            'priority' => 21,
        )
    );      

    // Enable Socials Top
    $wp_customize->add_setting(
      'enable_social_link_top',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('enable_social_link_top'),     
        )   
    );
    $wp_customize->add_control(
        'enable_social_link_top',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Socials Top', 'specal'),
            'section' => 'themesflat_header',
            'priority' => 22,
        )
    );

    // Enable Socials Header
    $wp_customize->add_setting(
      'enable_social_link_header',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('enable_social_link_header'),     
        )   
    );
    $wp_customize->add_control(
        'enable_social_link_header',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Socials Header', 'specal'),
            'section' => 'themesflat_header',
            'priority' => 22,
        )
    );      
  
    // Top bar background color
    $wp_customize->add_setting(
        'top_background_color',
        array(
            'default'           => themesflat_get_opt('top_background_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'top_background_color',
            array(
                'label'         => esc_html('Topbar Backgound', 'specal'),
                'section'       => 'themesflat_header',
                'settings'      => 'top_background_color',
                'priority'      => 23
            )
        )
    );

    // Top bar text color
    $wp_customize->add_setting(
        'topbar_textcolor',
        array(
            'default'           => themesflat_get_opt('topbar_textcolor'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'topbar_textcolor',
            array(
                'label'         => esc_html('Topbar Text Color', 'specal'),
                'section'       => 'themesflat_header',
                'settings'      => 'topbar_textcolor',
                'priority'      => 24
            )
        )
    );

    // Top Content
    $wp_customize->add_setting(
        'top_content',
        array(
            'default' => themesflat_customize_default_options2('top_content'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'top_content',
        array(
            'label' => esc_html( 'Content Left', 'specal' ),
            'section' => 'themesflat_header',
            'type' => 'textarea',
            'priority' => 25
        )
    ); 

    // Enable Top Content
    $wp_customize->add_setting(
      'enable_content_left_top',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_get_opt('enable_content_left_top'),     
        )   
    );
    $wp_customize->add_control(
        'enable_content_left_top',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Content Left Top', 'specal'),
            'section' => 'themesflat_header',
            'priority' => 26,
        )
    );

    // Enable Language Switch
    $wp_customize->add_setting(
      'enable_language_switch',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('enable_language_switch'),     
        )   
    );
    $wp_customize->add_control(
        'enable_language_switch',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Language Switch', 'specal'),
            'section' => 'themesflat_header',
            'priority' => 27,
        )
    );
    
   // Footer
    $wp_customize->add_section(
        'flat_footer',
        array(
            'title'         => esc_html('Footer', 'specal'),
            'priority'      => 4,
        )
    );        

    $wp_customize->remove_control('display_header_text');
    $wp_customize->remove_control('header_textcolor');  

    // Footer widget
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'custom-widget-footer', array(
        'label' => esc_html('footer widgets', 'specal'),
        'section' => 'flat_footer',
        'settings' => 'themesflat_options[info]',
        'priority' => 9
        ) )
    );    

    // Desc
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_widget_footer', array(
        'label' => esc_html('This section allow to change the layout and styles of footer widgets to match as you need', 'specal'),
        'section' => 'flat_footer',
        'settings' => 'themesflat_options[info]',
        'priority' => 10
        ) )
    );  

      // Gird columns Related Posts
    $wp_customize->add_setting(
        'footer_widget_areas',
        array(
            'default'           => themesflat_customize_default_options2('footer_widget_areas'),
            'sanitize_callback' => 'themesflat_sanitize_grid_post_related',
        )
    );
    $wp_customize->add_control(
        'footer_widget_areas',
        array(
            'type'      => 'select',           
            'section'   => 'flat_footer',
            'priority'  => 14,
            'label'     => esc_html('Columns  Footer', 'specal'),
            'choices'   => array(                
                1     => esc_html( '1 Columns', 'specal' ),
                2     => esc_html( '2 Columns', 'specal' ),
                3     => esc_html( '3 Columns', 'specal' ),
                4     => esc_html( '4 Columns', 'specal' ),              
            )
        )
    ); 

     //Footer Background image
    $wp_customize->add_setting(
        'footer_background_image',
        array(
            'default' => themesflat_customize_default_options2('footer_background_image'),
            'sanitize_callback' => 'esc_url_raw',
        )
    );    
    $wp_customize->add_control(
        new WP_Customize_Image_Control(
            $wp_customize,
            'footer_background_image',
            array(
               'label'          => esc_html( 'Upload your Footer Background  Image ', 'specal' ),
               'type'           => 'image',
               'section'        => 'flat_footer',
               'priority'       => 11,
            )
        )
    );     

    // Footer background color
    $wp_customize->add_setting(
        'footer_background_color',
        array(
            'default' => themesflat_customize_default_options2('footer_background_color'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control(
        new themesflat_ColorOverlay(
            $wp_customize,
            'footer_background_color',
            array(
                'label'         => esc_html('Footer Backgound', 'specal'),
                'section'       => 'flat_footer',
                'settings'      => 'footer_background_color',
                'priority'      => 12
            )
        )
    );

    // Footer text color
    $wp_customize->add_setting(
        'footer_text_color',
        array(
            'default'           => themesflat_customize_default_options2('footer_text_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_text_color',
            array(
                'label'         => esc_html('Footer Text Color', 'specal'),
                'section'       => 'flat_footer',
                'settings'      => 'footer_text_color',
                'priority'      => 13
            )
        )
    ); 

    // Footer title
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'custom-footer-content', array(
        'label' => esc_html('CUSTOM FOOTER', 'specal'),
        'section' => 'flat_footer',
        'settings' => 'themesflat_options[info]',
        'priority' => 14
        ) )
    );    

    // Desc
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_footer', array(
        'label' => esc_html('You can change the copyright text, show/hide the social icons on the footer.', 'specal'),
        'section' => 'flat_footer',
        'settings' => 'themesflat_options[info]',
        'priority' => 15
        ) )
    );

    // Enable Footer
    $wp_customize->add_setting(
      'enable_footer',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_get_opt('enable_footer'),     
        )   
    );
    $wp_customize->add_control(
        'enable_footer',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Footer', 'specal'),
            'section' => 'flat_footer',
            'priority' => 15,
        )
    );

    // Enable Business Financial
    $wp_customize->add_setting(
      'enable_page_call_out',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('enable_page_call_out'),     
        )   
    );
    $wp_customize->add_control(
        'enable_page_call_out',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Page Call Out', 'specal'),
            'section' => 'flat_footer',
            'priority' => 16,
        )
    );
    
    // page callout 
    $wp_customize->add_setting (
        'text_page_callout',
        array(
            'default' => themesflat_customize_default_options2('text_page_callout'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'text_page_callout',
        array(
            'type'      => 'textarea',
            'label'     => esc_html('Text Call Out', 'specal'),
            'section'   => 'flat_footer',
            'priority'  => 17
        )
    );

    // Text Button Call Out 
    $wp_customize->add_setting(
        'text_button_page_callout',
        array(
            'default'   =>  themesflat_get_opt('text_button_page_callout'),
            'sanitize_callback' =>  'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(        
        'text_button_page_callout',
        array(
            'type'      =>  'textarea',
            'label'     =>  esc_html('Text Button Call Out', 'specal'),
            'section'   =>  'flat_footer',
            'priority'  =>  18
        )
    );

    // Link Button Call Out
    $wp_customize->add_setting(
        'link_button_call_out',
        array(
            'default'   =>  themesflat_get_opt('link_button_call_out'),
            'sanitize_callback'  =>  'themesflat_sanitize_text'  
        )
    );
    $wp_customize->add_control(
        'link_button_call_out',
        array(
            'type'      => 'text' ,
            'label'     =>  esc_html('Link Button Call Out','specal'),   
            'section'   =>  'flat_footer',
            'priority'  =>  19
        )
    );
    
    // Footer Content
    $wp_customize->add_setting(
        'footer_copyright',
        array(
            'default' => themesflat_get_opt('footer_copyright'),
            'sanitize_callback' => 'themesflat_sanitize_text',
        )
    );
    $wp_customize->add_control(
        'footer_copyright',
        array(
            'label' => esc_html( 'Copyright', 'specal' ),
            'section' => 'flat_footer',
            'type' => 'textarea',
            'priority' => 21
        )
    ); 

    // Enable Socials Bottom,
    $wp_customize->add_setting(
      'enable_social_link_bottom',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('enable_social_link_bottom'),     
        )   
    );
    $wp_customize->add_control(
        'enable_social_link_bottom',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Socials Bottom', 'specal'),
            'section' => 'flat_footer',
            'priority' => 22,
        )
    ); 

     // Page Title Color
    $wp_customize->add_setting(
        'footer_border_color',
        array(
            'default'           => themesflat_customize_default_options2('footer_border_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_border_color',
            array(
                'label'         => esc_html('Footer Border Color', 'specal'),
                'section'       => 'flat_footer',
                'priority'      => 23
            )
        )
    );

    // Box control
    $wp_customize->add_setting(
        'footer_controls',
        array(
            'default' => themesflat_customize_default_options2('footer_controls'),
            'sanitize_callback' => 'themesflat_sanitize_text',
        )
    );
    $wp_customize->add_control( new themesflat_BoxControls($wp_customize,
        'footer_controls',
        array(
            'label' => esc_html( 'Footer Controls', 'specal' ),
            'section' => 'flat_footer',
            'type' => 'box-controls',
            'priority' => 24
        ))
    );
    
    // Color
    $wp_customize->add_panel('color_panel',array(
        'title'         => 'Color',
        'description'   => 'This is panel Description',
        'priority'      => 10,
    ));

    // ADD SECTION GENERAL
    $wp_customize->add_section('color_general',array(
        'title'         => 'General',
        'priority'      => 10,
        'panel'         => 'color_panel',
    ));

    // Heading Color Scheme
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'color_scheme', array(
        'label' => esc_html('SCHEME COLOR', 'specal'),
        'section' => 'color_general',
        'settings' => 'themesflat_options[info]',
        'priority' => 1
        ) )
    );    

    // Desc color scheme
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_color_schemer', array(
        'label' => esc_html('Select the color that will be used for theme color.','specal'),
        'section' => 'color_general',
        'settings' => 'themesflat_options[info]',
        'priority' => 2
        ) )
    );   

    $wp_customize->add_setting(
        'primary_color',
        array(
            'default'           => themesflat_customize_default_options2('primary_color'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control(
        new themesflat_ColorOverlay(
            $wp_customize,
            'primary_color',
            array(
                'label'         => esc_html('Scheme color', 'specal'),
                'section'       => 'color_general',
                'settings'      => 'primary_color',
                'priority'      => 3
            )
        )
    );    

    // Body Color
    $wp_customize->add_setting(
        'body_text_color',
        array(
            'default'           => themesflat_customize_default_options2('body_text_color'),
            'sanitize_callback' => 'sanitize_hex_color',
            'transport'         => 'postMessage'
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'body_text_color',
            array(
                'label' => esc_html('Body Color', 'specal'),
                'section' => 'color_general',
                'priority' => 4
            )
        )
    ); 

    // Body Background Color
    $wp_customize->add_setting(
        'body_background_color',
        array(
            'default'           => themesflat_customize_default_options2('body_background_color'),
            'sanitize_callback' => 'sanitize_hex_color',
            'transport'         => 'postMessage'
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'body_background_color',
            array(
                'label' => esc_html('Body Background Color', 'specal'),
                'section' => 'color_general',
                'priority' => 4
            )
        )
    ); 

    // ADD SECTION HEADER COLOR
    $wp_customize->add_section('color_header',array(
        'title'=>'Header',
        'priority'=>11,
        'panel'=>'color_panel',
    ));

    // Title section portfolio
    $wp_customize->add_setting('themesflat_options[info]', array(
        'type'              => 'info_control',
        'capability'        => 'edit_theme_options',
        'sanitize_callback' => 'esc_attr',            
        )
    );
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'topbar_color', array(
        'label' => esc_html('Top Color', 'specal'),
        'section' => 'color_header',
        'settings' => 'themesflat_options[info]',
        'priority' => 1
        ) )
    );  

    // Top bar background color
    $wp_customize->add_setting(
        'top_background_color',
        array(
            'default'           => themesflat_get_opt('top_background_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'top_background_color',
            array(
                'label'         => esc_html('Topbar Backgound', 'specal'),
                'section'       => 'color_header',
                'settings'      => 'top_background_color',
                'priority'      => 2
            )
        )
    );

    // Top bar text color
    $wp_customize->add_setting(
        'topbar_textcolor',
        array(
            'default'           => themesflat_get_opt('topbar_textcolor'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'topbar_textcolor',
            array(
                'label'         => esc_html('Topbar Text Color', 'specal'),
                'section'       => 'color_header',
                'settings'      => 'topbar_textcolor',
                'priority'      => 3
            )
        )
    );

    // MENU COLOR
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'menu_color', array(
        'label' => esc_html('MENU COLOR', 'specal'),
        'section' => 'color_header',
        'settings' => 'themesflat_options[info]',
        'priority' => 3
        ) )
    );   

    // Menu Background
    $wp_customize->add_setting(
        'mainnav_backgroundcolor',
        array(
            'default'   => themesflat_customize_default_options2('mainnav_backgroundcolor'),
            'sanitize_callback' => 'esc_attr'
        )
    );
    $wp_customize->add_control(
        new themesflat_ColorOverlay(
            $wp_customize,
            'mainnav_backgroundcolor',
            array(
                'label' => esc_html('Mainnav Background', 'specal'),
                'description'   => esc_html__(' Opacity =1 for Background Color', 'specal'),
                'section' => 'color_header',
                'priority' => 5
            )
        )
    );   

    // Menu a color
    $wp_customize->add_setting(
        'mainnav_color',
        array(
            'default'           => themesflat_customize_default_options2('mainnav_color'),
            'sanitize_callback' => 'sanitize_hex_color'
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'mainnav_color',
            array(
                'label' => esc_html('Mainnav a color', 'specal'),
                'section' => 'color_header',
                'priority' => 6
            )
        )
    );

    // Menu a:hover color
    $wp_customize->add_setting(
        'mainnav_hover_color',
        array(
            'default'           => themesflat_customize_default_options2('mainnav_hover_color'),
            'sanitize_callback' => 'sanitize_hex_color'
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'mainnav_hover_color',
            array(
                'label' => esc_html('Mainnav a:hover color', 'specal'),
                'section' => 'color_header',
                'priority' => 7
            )
        )
    );

    // Sub menu a color
    $wp_customize->add_setting(
        'sub_nav_color',
        array(
            'default'           => themesflat_customize_default_options2('sub_nav_color'),
            'sanitize_callback' => 'sanitize_hex_color'
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'sub_nav_color',
            array(
                'label' => esc_html('Sub nav a color', 'specal'),
                'section' => 'color_header',
                'priority' => 8
            )
        )
    );

    // Sub nav background
    $wp_customize->add_setting(
        'sub_nav_background',
        array(
            'default'           => themesflat_customize_default_options2('sub_nav_background'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'sub_nav_background',
            array(
                'label' => esc_html('Sub nav background color', 'specal'),
                'section' => 'color_header',
                'priority' => 9
            )
        )
    );

    // Border color li sub nav
    $wp_customize->add_setting(
        'border_clor_sub_nav',
        array(
            'default'           => themesflat_customize_default_options2('border_clor_sub_nav'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'border_clor_sub_nav',
            array(
                'label' => esc_html('Border color sub nav', 'specal'),
                'section' => 'color_header',
                'priority' => 10
            )
        )
    );

    // Sub nav background hover
    $wp_customize->add_setting(
        'sub_nav_background_hover',
        array(
            'default'   => themesflat_customize_default_options2('sub_nav_background_hover'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'sub_nav_background_hover',
            array(
                'label' => esc_html('Sub-menu background color hover', 'specal'),
                'section' => 'color_header',
                'priority' => 11
            )
        )
    );     

    // ADD SECTION COLOR FOOTER
    $wp_customize->add_section('color_footer',array(
        'title'=>'Footer',
        'priority'=>12,
        'panel'=>'color_panel',
    ));    
        
    // Footer text color
    $wp_customize->add_setting(
        'footer_text_color',
        array(
            'default'           => themesflat_customize_default_options2('footer_text_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_text_color',
            array(
                'label'         => esc_html('Footer Text Color', 'specal'),
                'section'       => 'color_footer',
                'settings'      => 'footer_text_color',
                'priority'      => 13
            )
        )
    );

    // bottom background color
    $wp_customize->add_setting(
        'bottom_background_color',
        array(
            'default'           => themesflat_customize_default_options2('bottom_background_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'bottom_background_color',
            array(
                'label'         => esc_html('Bottom Backgound', 'specal'),
                'section'       => 'color_footer',
                'settings'      => 'bottom_background_color',
                'priority'      => 18
            )
        )
    );

    // Bottom text color
    $wp_customize->add_setting(
        'bottom_text_color',
        array(
            'default'           => themesflat_customize_default_options2('bottom_text_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'bottom_text_color',
            array(
                'label'         => esc_html('Bottom Text Color', 'specal'),
                'section'       => 'color_footer',
                'settings'      => 'bottom_text_color',
                'priority'      => 19
            )
        )
    );   

   // Footer 
    $wp_customize->add_section(
        'themesflat_footer',
        array(
            'title'         => esc_html('Footer', 'specal'),
            'priority'      => 4,
        )
    );        

    $wp_customize->remove_control('display_header_text');
    $wp_customize->remove_control('header_textcolor'); 
   
    // Section Blog
    $wp_customize->add_section(
        'blog_options',
        array(
            'title' => esc_html('Post', 'specal'),
            'priority' => 13,
        )
    );

    // Heading Blog
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'bloglist', array(
        'label' => esc_html('Blog List', 'specal'),
        'section' => 'blog_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 1
        ) )
    );    

    // Desc blog
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_bloglist', array(
        'label' => esc_html('All options in this section will be used to make style for blog page.','specal'),
        'section' => 'blog_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 2
        ) )
    );   

    $wp_customize->add_setting(
        'blog_layout',
        array(
            'default'           => themesflat_customize_default_options2('blog_layout'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'blog_layout',
        array (
            'type'      => 'select',           
            'section'   => 'blog_options',
            'priority'  => 3,
            'label'         => esc_html('List Sidebar Position', 'specal'),
            'choices'   => array (
                'sidebar-right' => esc_html( 'Sidebar Right','specal' ),
                'sidebar-left'=>  esc_html( 'Sidebar Left','specal' ),
                'fullwidth' =>   esc_html( 'Full Width','specal' )
                ) ,
        )
    );

    $wp_customize->add_setting(
        'blog_archive_layout',
        array(
            'default'           => themesflat_customize_default_options2('blog_archive_layout'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'blog_archive_layout',
        array (
            'type'      => 'select',           
            'section'   => 'blog_options',
            'priority'  => 3,
            'label'         => esc_html('Blog Layout', 'specal'),
            'choices'   => array (
                'blog-list' =>  esc_html( 'Blog List','specal' ),
                'blog-grid'=> esc_html( 'Blog Grid','specal' ),
                )  
        )
    );

    // Gird columns Related Posts
    $wp_customize->add_setting(
        'blog_grid_columns',
        array(
            'default'           => themesflat_customize_default_options2('blog_grid_columns'),
            'sanitize_callback' => 'themesflat_sanitize_grid_post_related',
        )
    );
    $wp_customize->add_control(
        'blog_grid_columns',
        array(
            'type'      => 'select',           
            'section'   => 'blog_options',
            'priority'  => 4,
            'label'     => esc_html('Post Grid Columns', 'specal'),
            'choices'   => array(                
                2     => esc_html( '2 Columns', 'specal' ),
                3     => esc_html( '3 Columns', 'specal' ),               
            )
        )
    );

    // Blog Sidebar List
    $wp_customize->add_setting (
        'blog_sidebar_list',
        array(
            'default'           => themesflat_customize_default_options2('blog_sidebar_list'),
            'sanitize_callback' => 'esc_html',
        )
    );
    $wp_customize->add_control( new themesflat_DropdownSidebars($wp_customize,
        'blog_sidebar_list',
        array(
            'type'      => 'dropdown',           
            'section'   => 'blog_options',
            'priority'  => 3,
            'label'         => esc_html('List Sidebar Position', 'specal'),
            
        ))
    );

    // Excerpt
    $wp_customize->add_setting(
        'blog_archive_post_excepts_length',
        array(
            'sanitize_callback' => 'absint',
            'default'           => themesflat_customize_default_options2('blog_archive_post_excepts_length'),
        )       
    );
    $wp_customize->add_control( 'blog_archive_post_excepts_length', array(
        'type'        => 'number',
        'priority'    => 4,
        'section'     => 'blog_options',
        'label'       => esc_html('Post Excepts Length', 'specal'),
        'input_attrs' => array(
            'min'   => 10,
            'max'   => 200,
            'step'  => 5
        ),
    ) );

    // Show Header Content
    $wp_customize->add_setting ( 
        'show_header_content',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox' ,
            'default' => themesflat_customize_default_options2('show_header_content'),     
        )
    );
    $wp_customize->add_control(
        'show_header_content',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show Header Content', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 5
        )
    );

    // Show Post Content
    $wp_customize->add_setting ( 
        'blog_show_content',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox' ,
            'default' => themesflat_customize_default_options2('blog_show_content'),     
        )
    );
    $wp_customize->add_control(
        'blog_show_content',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show Post Content', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 6
        )
    );

    // Show Read More
    $wp_customize->add_setting (
        'show_read_more',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('show_read_more'),     
        )
    );
    $wp_customize->add_control(
        'show_read_more',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html__('Show Read More', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 7
        )
    );

    // Show Post Meta
    $wp_customize->add_setting ( 
        'blog_archive_show_post_meta',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox' ,
            'default' => themesflat_customize_default_options2('blog_archive_show_post_meta'),     
        )
    );
    $wp_customize->add_control(
        'blog_archive_show_post_meta',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show Post Meta', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 8
        )
    );

    // Read More Text
    $wp_customize->add_setting (
        'blog_read_more_text',
        array(
            'default' => themesflat_customize_default_options2('blog_read_more_text'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'blog_read_more_text',
        array(
            'type'      => 'text',
            'label'     => esc_html('Read More Text', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 9
        )
    );

    // Pagination
    $wp_customize->add_setting(
        'blog_archive_pagination_style',
        array(
            'default'           => themesflat_customize_default_options2('blog_archive_pagination_style'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'blog_archive_pagination_style',
        array(
            'type'      => 'select',           
            'section'   => 'blog_options',
            'priority'  => 10,
            'label'         => esc_html__('Pagination Style', 'specal'),
            'choices'   => array(
                'pager'     => esc_html__('Pager','specal'),
                'numeric'         =>  esc_html__('Numeric','specal'),
                'pager-numeric'         =>  esc_html__('Pager & Numeric','specal'),
                'loadmore' =>  esc_html__( 'Load More', 'specal' )
            ),
        )
    );

    // Header Blog Single    
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'blogsingle', array(
        'label' => esc_html('Blog Single', 'specal'),
        'section' => 'blog_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 9
        ) )
    );    

    // Desc Blog Single
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_blogsingle', array(
        'label' => esc_html('Also, you can change the style for blog single to make your site unique.','specal'),
        'section' => 'blog_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 10
        ) )
    );   

    // Show Post Navigator
    $wp_customize->add_setting (
        'show_post_navigator',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('show_post_navigator'),     
        )
    );
    $wp_customize->add_control( 
        'show_post_navigator',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show Post Navigator', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 12
        )
    );
      
    // Show Related Posts
    $wp_customize->add_setting (
        'show_related_post',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => 0,     
        )
    );
    $wp_customize->add_control( 
        'show_related_post',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show Related Posts', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 15
        )
    );

    //Related Posts Style
    $wp_customize->add_setting(
        'related_post_style',
        array(
            'default'           => themesflat_customize_default_options2('related_post_style'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'related_post_style',
        array(
            'type'      => 'select',           
            'section'   => 'blog_options',
            'priority'  => 16,
            'label'         => esc_html('Related Posts Style', 'specal'),
            'choices'   => array(
                'blog-list' => esc_html( 'Blog List','specal' ),
                'blog-grid'=>   esc_html( 'Blog Grid','specal' ),
        ))
    );

    // Gird columns Related Posts
    $wp_customize->add_setting(
        'grid_columns_post_related',
        array(
            'default'           => 3,
            'sanitize_callback' => 'themesflat_sanitize_grid_post_related',
        )
    );
    $wp_customize->add_control(
        'grid_columns_post_related',
        array(
            'type'      => 'select',           
            'section'   => 'blog_options',
            'priority'  => 17,
            'label'     => esc_html('Columns Of Related Posts', 'specal'),
            'choices'   => array(                
                2     => esc_html( '2 Columns', 'specal' ),
                3     => esc_html( '3 Columns', 'specal' ),
                                
            )
        )
    );

    // Number Of Related Posts
    $wp_customize->add_setting (
        'number_related_post',
        array(
            'default' => esc_html('3', 'specal'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'number_related_post',
        array(
            'type'      => 'text',
            'label'     => esc_html('Number Of Related Posts', 'specal'),
            'section'   => 'blog_options',
            'priority'  => 18
        )
    );

    // Section portfolio
    $wp_customize->add_section(
        'portfolio_options',
        array(
            'title' => esc_html('Portfolio', 'specal'),
            'priority' => 14,
        )
    );

    // Heading portfolio
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'portfoliolist', array(
        'label' => esc_html('Portfolio List', 'specal'),
        'section' => 'portfolio_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 1
        ) )
    );    

    // Desc portfolio
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_portfoliolist', array(
        'label' => esc_html('Change options in this section to custom style for Portfolio listing page.','specal'),
        'section' => 'portfolio_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 2
        ) )
    );   

    // Show filter portfolio
    $wp_customize->add_setting (
        'show_filter_portfolio',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('show_filter_portfolio'),     
        )
    );
    $wp_customize->add_control( 
        'show_filter_portfolio',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show filter ', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 3
        )
    );   

    // Portfolios Style
    $wp_customize->add_setting(
        'portfolio_style',
        array(
            'default'           => 'grid',
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'portfolio_style',
        array(
            'type'      => 'select',           
            'section'   => 'portfolio_options',
            'priority'  => 4,            
            'label'         => esc_html('Portfolio Style', 'specal'),
            'choices'   => array(
                'grid'           => esc_html( 'Grid', 'specal' ),
                'no-margin'         =>   esc_html( 'Grid No Margin', 'specal' ) ,
        ))
    );

    // Gird columns portfolio
    $wp_customize->add_setting(
        'portfolio_grid_columns',
        array(
            'default'           => themesflat_get_opt('portfolio_grid_columns'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control(
        'portfolio_grid_columns',
        array(
            'type'      => 'select',           
            'section'   => 'portfolio_options',
            'priority'  => 5,
            'label'     => esc_html('Grid Columns', 'specal'),
            'choices'   => array(
                'one-half'     => esc_html( '2 Columns', 'specal' ),
                'one-three'     => esc_html( '3 Columns', 'specal' ),
                'one-four'     => esc_html( '4 Columns', 'specal' ),
                'one-five'     => esc_html( '5 Columns', 'specal' )
            )
        )
    );

    // Pagination portfolio
    $wp_customize->add_setting(
        'portfolio_archive_pagination_style',
        array(
            'default'           => themesflat_get_opt('portfolio_archive_pagination_style'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'portfolio_archive_pagination_style',
        array(
            'type'      => 'select',           
            'section'   => 'portfolio_options',
            'priority'  => 6,
            'label'         => esc_html('Pagination Style', 'specal'),
            'choices'   => array(
                'pager-numeric'           =>  esc_html( 'Pager & Numeric', 'specal' ),
                'loadmore'         =>   esc_html( 'Load More', 'specal' ) ,
        ))
    );

    // post per page portfolio
    $wp_customize->add_setting (
        'portfolio_post_perpage',
        array(
            'default' => esc_html('9', 'specal'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'portfolio_post_perpage',
        array(
            'type'      => 'text',
            'label'     => esc_html('Posts Per Page', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 7
        )
    );

    // Order By portfolio
    $wp_customize->add_setting(
        'portfolio_order_by',
        array(
            'default' => 'date',
            'sanitize_callback' => 'themesflat_sanitize_portfolio_order',
        )
    );
    $wp_customize->add_control(
        'portfolio_order_by',
        array(
            'type'      => 'select',
            'label'     => esc_html('Order By', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 8,
            'choices' => array(
                'date'          => esc_html( 'Date', 'specal' ),
                'id'            => esc_html( 'Id', 'specal' ),
                'author'        => esc_html( 'Author', 'specal' ),
                'title'         => esc_html( 'Title', 'specal' ),
                'modified'      => esc_html( 'Modified', 'specal' ),
                'comment_count' => esc_html( 'Comment Count', 'specal' ),
                'menu_order'    => esc_html( 'Menu Order', 'specal' )
            )        
        )
    ); 

    // Order Direction portfolio
    $wp_customize->add_setting(
        'portfolio_order_direction',
        array(
            'default' => 'DESC',
            'sanitize_callback' => 'themesflat_sanitize_portfolio_order_direction',
        )
    );
    $wp_customize->add_control(
        'portfolio_order_direction',
        array(
            'type'      => 'select',
            'label'     => esc_html('Order Direction', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 9,
            'choices' => array(
                'DESC' => esc_html( 'Descending', 'specal' ),
                'ASC'  => esc_html( 'Assending', 'specal' )
            )        
        )
    ); 
    
    // Header Portfolio Single    
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'portfoliosingle', array(
        'label' => esc_html('SINGLE PORTFOLIO', 'specal'),
        'section' => 'portfolio_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 10
        ) )
    );    

    // Desc Portfolio Single
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_portfoliosingle', array(
        'label' => esc_html('Also, you can change the style for blog single to make your site unique.','specal'),
        'section' => 'portfolio_options',
        'settings' => 'themesflat_options[info]',
        'priority' => 11
        ) )
    );   

     // Portfolios Single Style
    $wp_customize->add_setting(
        'portfolio_single_style',
        array(
            'default'           => themesflat_customize_default_options2('portfolio_single_style'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'portfolio_single_style',
        array(
            'type'      => 'select',           
            'section'   => 'portfolio_options',
            'priority'  => 12,
            'label'         => esc_html('Portfolio Single style', 'specal'),
            'choices'   => array(
                'full_content'    =>      esc_html( 'Full Content', 'specal' ),
                'right_content'         =>   esc_html( 'Right Content', 'specal' ) ,
        ))
    );   

    // Show Post Navigator portfolio
    $wp_customize->add_setting (
        'portfolio_show_post_navigator',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('portfolio_show_post_navigator'),     
        )
    );
    $wp_customize->add_control( 
        'portfolio_show_post_navigator',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show Single Navigator', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 12
        )
    );

    // Show Related Portfolios
    $wp_customize->add_setting (
        'show_related_portfolio',
        array (
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('show_related_portfolio'),     
        )
    );
    $wp_customize->add_control( 
        'show_related_portfolio',
        array(
            'type'      => 'checkbox',
            'label'     => esc_html('Show Related Portfolios', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 13
        )
    );

    // Title widget reated
    $wp_customize->add_setting (
        'title_related_portfolio',
        array(
            'default' => esc_html('Related Portfolio', 'specal'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'title_related_portfolio',
        array(
            'type'      => 'text',
            'label'     => esc_html('Portfolio panel title', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 14
        )
    );

    // Related Portfolios Style
    $wp_customize->add_setting(
        'related_portfolio_style',
        array(
            'default'           => themesflat_customize_default_options2('related_portfolio_style'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'related_portfolio_style',
        array(
            'type'      => 'select',           
            'section'   => 'portfolio_options',
            'priority'  => 15,
            'label'         => esc_html('Related Portfolio Style', 'specal'),
            'choices'   => array(
                'grid'           =>  esc_html( 'Grid', 'specal' ),
                'no-margin'         =>   esc_html( 'Grid No Margin', 'specal' )
        ))
    );

    // Gird columns portfolio related
    $wp_customize->add_setting(
        'grid_columns_portfolio_related',
        array(
            'default'           => 'one-three',
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control(
        'grid_columns_portfolio_related',
        array(
            'type'      => 'select',           
            'section'   => 'portfolio_options',
            'priority'  => 16,
            'label'     => esc_html('Columns Count', 'specal'),
            'choices'   => array(
                'one-half'     => esc_html( '2 Columns', 'specal' ),
                'one-three'     => esc_html( '3 Columns', 'specal' )
            )
        )
    );
    
    // Number Of Related Portfolios
    $wp_customize->add_setting (
        'number_related_portfolio',
        array(
            'default' => themesflat_customize_default_options2('number_related_portfolio'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'number_related_portfolio',
        array(
            'type'      => 'text',
            'label'     => esc_html('Number Of Related Portfolios', 'specal'),
            'section'   => 'portfolio_options',
            'priority'  => 17
        )
    );

    // Section Typography
    $wp_customize->add_section(
        'flat_typography',
        array(
            'title' => esc_html('Typography', 'specal'),
            'priority' => 6,            
        )
    );

    // Heading Typography
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'custom-typography', array(
        'label' => esc_html('BODY FONT', 'specal'),
        'section' => 'flat_typography',
        'settings' => 'themesflat_options[info]',
        'priority' => 2
        ) )
    );    

    // Desc Typography
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_logo', array(
        'label' => esc_html('You can modify the font family, size, color, ... for global content.', 'specal'),
        'section' => 'flat_typography',
        'settings' => 'themesflat_options[info]',
        'priority' => 3
        ) )
    );

    
    // Page title and breadcrumb
    $wp_customize->add_panel('page_title_panel',array(
        'title'         => esc_html__('Page Title & Breadcrumb','specal'),
        'description'   => 'This is panel Description',
        'priority'      => 10,
    ));

    // ADD SECTION PAGE TITLE
    $wp_customize->add_section('page_title_style',array(
        'title'         => esc_html__('Page Title Style','specal'),
        'priority'      => 10,
        'panel'         => 'page_title_panel',
    ));

   // Heading Color Scheme
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'page_title_style', array(
        'label' => esc_html__('Page Title Style', 'specal'),
        'section' => 'page_title_style',
        'settings' => 'themesflat_options[info]',
        'priority' => 1
        ) )
    );

    //Page Title Background Image
    $wp_customize->add_setting(
        'page_title_background_image',
        array(
            'default' => themesflat_customize_default_options2('page_title_background_image'),
            'sanitize_callback' => 'esc_url_raw',
        )
    );    
    $wp_customize->add_control(
        new WP_Customize_Image_Control(
            $wp_customize,
            'page_title_background_image',
            array(
               'label'          => esc_html( 'Upload your Page Title Background  Image ', 'specal' ),
               'type'           => 'image',
               'section'        => 'page_title_style',
               'priority'       => 1,
            )
        )
    );   

    // Header page title
    $wp_customize->add_setting(
      'show_page_title',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('show_page_title'),     
        )   
    );
    $wp_customize->add_control(
        'show_page_title',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Show page title', 'specal'),
            'section' => 'page_title_style',
            'priority' => 2,
        )
    ); 
    
    // Page Title Color
    $wp_customize->add_setting(
        'page_title_text_color',
        array(
            'default'           => themesflat_customize_default_options2('page_title_text_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'page_title_text_color',
            array(
                'label'         => esc_html('Page Title Heading Text Color', 'specal'),
                'section'       => 'page_title_style',
                'priority'      => 3
            )
        )
    );

    // Page Title Overlay
    $wp_customize->add_setting(
        'page_title_overlay_color',
        array(
            'default'           => themesflat_customize_default_options2('page_title_overlay_color'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( new themesflat_ColorOverlay(
            $wp_customize,
            'page_title_overlay_color',
            array(
                'label'         => esc_html__('Page Title Overlay Color', 'specal'),
                'description'   => esc_html__(' Opacity =1 for Background Color', 'specal'),
                'section'       => 'page_title_style',
                'priority'      => 4
            )
        )
    );

    // Page Title Color
    $wp_customize->add_setting(
        'page_title_border_color',
        array(
            'default'           => themesflat_customize_default_options2('page_title_border_color'),
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'page_title_border_color',
            array(
                'label'         => esc_html('Page Title Border Color', 'specal'),
                'section'       => 'page_title_style',
                'priority'      => 5
            )
        )
    );

    // Box control
    $wp_customize->add_setting(
        'page_title_controls',
        array(
            'default' => themesflat_customize_default_options2('page_title_controls'),
            'sanitize_callback' => 'themesflat_sanitize_text',
        )
    );
    $wp_customize->add_control( new themesflat_BoxControls($wp_customize,
        'page_title_controls',
        array(
            'label' => esc_html( 'Page Title Controls', 'specal' ),
            'section' => 'page_title_style',
            'type' => 'box-controls',
            'priority' => 6
        ))
    ); 


    // Header page title
    $wp_customize->add_setting(
      'show_page_title_heading',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('show_page_title_heading'),     
        )   
    );
    $wp_customize->add_control(
        'show_page_title_heading',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Show page title heading', 'specal'),
            'section' => 'page_title_style',
            'priority' => 7,
        )
    );

    // ADD SECTION BREADCRUMB
    $wp_customize->add_section('page_break_crumb_section',array(
        'title'         => esc_html__('Page Breadcrumb','specal'),
        'priority'      => 10,
        'panel'         => 'page_title_panel',
    ));

   // Breadcrumb section
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'page_break_crumb_section', array(
        'label' => esc_html__('Page Breadcrumb', 'specal'),
        'section' => 'page_break_crumb_section',
        'settings' => 'themesflat_options[info]',
        'priority' => 1
        ) )
    );  

    // Breadcrumb
    $wp_customize->add_setting(
      'breadcrumb_enabled',
        array(
            'sanitize_callback' => 'themesflat_sanitize_checkbox',
            'default' => themesflat_customize_default_options2('breadcrumb_enabled'),     
        )   
    );
    $wp_customize->add_control( 
        'breadcrumb_enabled',
        array(
            'type' => 'checkbox',
            'label' => esc_html('Enable Breadcrumb', 'specal'),
            'section' => 'page_break_crumb_section',
            'priority' => 14,
        )
    );    

    // Breadcrumb Prefix
    $wp_customize->add_setting (
        'breadcrumb_prefix',
        array(
            'default' => themesflat_customize_default_options2('breadcrumb_prefix') ,
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'breadcrumb_prefix',
        array(
            'type'      => 'text',
            'label'     => esc_html('Breadcrumb Prefix', 'specal'),
            'section'   => 'page_break_crumb_section',
            'priority'  => 15
        )
    );  

    // Breadcrumb Separator
    $wp_customize->add_setting (
        'breadcrumb_separator',
        array(
            'default' => themesflat_customize_default_options2('breadcrumb_separator'),
            'sanitize_callback' => 'themesflat_sanitize_text'
        )
    );
    $wp_customize->add_control(
        'breadcrumb_separator',
        array(
            'type'      => 'text',
            'label'     => esc_html('Breadcrumb Separator', 'specal'),
            'section'   => 'page_break_crumb_section',
            'priority'  => 16
        )
    ); 

    // Body fonts
    $wp_customize->add_setting(
        'body_font_name',
        array(
            'default' => themesflat_customize_default_options2('body_font_name'),
            'sanitize_callback' => 'esc_html',
        )
    );
    $wp_customize->add_control( new themesflat_Typography($wp_customize,
        'body_font_name',
        array(
            'label' => esc_html( 'Font name/style/sets', 'specal' ),
            'section' => 'flat_typography',
            'type' => 'typography',
            'fields' => array('family','style','line_height','size'),
            'priority' => 4
        ))
    );  

    // Headings fonts
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'custom-heading-font', array(
        'label' => esc_html('Headings fonts', 'specal'),
        'section' => 'flat_typography',
        'settings' => 'themesflat_options[info]',
        'priority' => 8
        ) )
    );    

    // Desc font
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_customizer_heading-font', array(
        'label' => esc_html('You can modify the font options for your headings. h1, h2, h3, h4, ...', 'specal'),
        'section' => 'flat_typography',
        'settings' => 'themesflat_options[info]',
        'priority' => 9
        ) )
    );   

    $wp_customize->add_setting(
        'headings_font_name',
        array(
            'default' => themesflat_customize_default_options2('headings_font_name'),
            'sanitize_callback' => 'esc_html',
        )
    );
    $wp_customize->add_control( new themesflat_Typography($wp_customize,
        'headings_font_name',
        array(
            'label' => esc_html( 'Font name/style/sets', 'specal' ),
            'section' => 'flat_typography',
            'type' => 'typography',
            'fields' => array('family','style'),
            'priority' => 11
        ))
    );

    // H1 size
    $wp_customize->add_setting(
        'h1_size',
        array(
            'sanitize_callback' => 'absint',
            'default'           => themesflat_customize_default_options2('h1_size'),
        )       
    );
    $wp_customize->add_control( 'h1_size', array(
        'type'        => 'number',
        'priority'    => 13,
        'section'     => 'flat_typography',
        'label'       => esc_html('H1 font size (px)', 'specal'),
        'input_attrs' => array(
            'min'   => 10,
            'max'   => 60,
            'step'  => 1,
            'style' => 'margin-bottom: 15px; padding: 10px;',
        ),
    ) );

    // H2 size
    $wp_customize->add_setting(
        'h2_size',
        array(
            'sanitize_callback' => 'absint',
            'default'           =>  themesflat_customize_default_options2('h2_size'),
        )       
    );
    $wp_customize->add_control( 'h2_size', array(
        'type'        => 'number',
        'priority'    => 14,
        'section'     => 'flat_typography',
        'label'       => esc_html('H2 font size (px)', 'specal'),
        'input_attrs' => array(
            'min'   => 10,
            'max'   => 60,
            'step'  => 1,
            'style' => 'margin-bottom: 15px; padding: 10px;',
        ),
    ) );

    // H3 size
    $wp_customize->add_setting(
        'h3_size',
        array(
            'sanitize_callback' => 'absint',
            'default'           => themesflat_customize_default_options2('h3_size'),
        )       
    );
    $wp_customize->add_control( 'h3_size', array(
        'type'        => 'number',
        'priority'    => 15,
        'section'     => 'flat_typography',
        'label'       => esc_html('H3 font size (px)', 'specal'),
        'input_attrs' => array(
            'min'   => 10,
            'max'   => 60,
            'step'  => 1,
            'style' => 'margin-bottom: 15px; padding: 10px;',
        ),
    ) );

    // H4 size
    $wp_customize->add_setting(
        'h4_size',
        array(
            'sanitize_callback' => 'absint',
            'default'           =>  themesflat_customize_default_options2('h4_size'),
        )       
    );
    $wp_customize->add_control( 'h4_size', array(
        'type'        => 'number',
        'priority'    => 16,
        'section'     => 'flat_typography',
        'label'       => esc_html('H4 font size (px)', 'specal'),
        'input_attrs' => array(
            'min'   => 10,
            'max'   => 60,
            'step'  => 1,
            'style' => 'margin-bottom: 15px; padding: 10px;',
        ),
    ) );

    // H5 size
    $wp_customize->add_setting(
        'h5_size',
        array(
            'sanitize_callback' => 'absint',
            'default'           =>  themesflat_customize_default_options2('h5_size'),
        )       
    );
    $wp_customize->add_control( 'h5_size', array(
        'type'        => 'number',
        'priority'    => 17,
        'section'     => 'flat_typography',
        'label'       => esc_html('H5 font size (px)', 'specal'),
        'input_attrs' => array(
            'min'   => 10,
            'max'   => 60,
            'step'  => 1,
            'style' => 'margin-bottom: 15px; padding: 10px;',
        ),
    ) );

    // H6 size
    $wp_customize->add_setting(
        'h6_size',
        array(
            'sanitize_callback' => 'absint',
            'default'           =>  themesflat_customize_default_options2('h6_size'),
        )       
    );
    $wp_customize->add_control( 'h6_size', array(
        'type'        => 'number',
        'priority'    => 18,
        'section'     => 'flat_typography',
        'label'       => esc_html('H6 font size (px)', 'specal'),
        'input_attrs' => array(
            'min'   => 10,
            'max'   => 60,
            'step'  => 1,
            'style' => 'margin-bottom: 15px; padding: 10px;',
        ),
    ) );

    // Heading Menu fonts
    $wp_customize->add_setting('themesflat_options[info]', array(
            'type'              => 'info_control',
            'capability'        => 'edit_theme_options',
            'sanitize_callback' => 'esc_attr',            
        )
    );
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'menu_fonts', array(
        'label' => esc_html('Menu fonts', 'specal'),
        'section' => 'flat_typography',
        'settings' => 'themesflat_options[info]',
        'priority' => 19
        ) )
    );

    // Menu Font Name
    $wp_customize->add_setting(
        'menu_font_name',
        array(
            'default' => themesflat_customize_default_options2('menu_font_name'),
                'sanitize_callback' => 'esc_html',
        )
    );
    $wp_customize->add_control( new themesflat_Typography($wp_customize,
        'menu_font_name',
        array(
            'label' => esc_html( 'Font name/style/sets', 'specal' ),
            'section' => 'flat_typography',
            'type' => 'typography',
            'fields' => array('family','style','size','line_height'),
            'priority' => 20
        ))
    );

    // Layout Version
    $wp_customize->add_setting(
        'layout_version',
        array(
            'default'           => themesflat_customize_default_options2('layout_version'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control( 
        'layout_version',
        array(
            'type'      => 'select',           
            'section'   => 'colors',
            'priority'  => 7,
            'label'         => esc_html('Layout version', 'specal'),
            'choices'   => array(
                'wide'           =>  esc_html('Wide','specal'),
                'boxed'         =>   esc_html('Boxed','specal'),
        ))
    );

    // Sidebars
    $wp_customize->add_control( new themesflat_Info( $wp_customize, 'layout_body', array(
        'label' => esc_html('SIDEBAR', 'specal'),
        'section' => 'colors',
        'settings' => 'themesflat_options[info]',
        'priority' => 10
        ) )
    );    

    // Desc
    $wp_customize->add_control( new themesflat_Desc_Info( $wp_customize, 'desc_color_scheme', array(
        'label' => esc_html('Select the position of sidebar that you wish to display.','specal'),
        'section' => 'colors',
        'settings' => 'themesflat_options[info]',
        'priority' => 11
        ) )
    );   

    $wp_customize->add_setting(
        'page_layout',
        array(
            'default'           => themesflat_customize_default_options2('page_layout'),
            'sanitize_callback' => 'esc_attr',
        )
    );
    $wp_customize->add_control(
        'page_layout',
        array (
            'type'      => 'select',           
            'section'   => 'colors',
            'priority'  => 12,
            'label'         => esc_html('List Sidebar Position', 'specal'),
            'choices'   => array (
                'sidebar-right' =>  esc_html( 'Sidebar Right','specal' ),
                'sidebar-left'=>   esc_html( 'Sidebar Left','specal' ),
                'fullwidth'=>   esc_html( 'Full Width','specal' ),
        ))
    );

    $wp_customize->add_setting (
        'page_sidebar_list',
        array(
            'default'           => themesflat_customize_default_options2('page_sidebar_list'),
            'sanitize_callback' => 'esc_html',
        )
    );
    $wp_customize->add_control( new themesflat_DropdownSidebars($wp_customize,
        'page_sidebar_list',
        array(
            'type'      => 'dropdown',           
            'section'   => 'colors',
            'priority'  => 13,
            'label'         => esc_html('List Sidebar Position', 'specal'),            
        ))
    );
}

add_action( 'customize_register', 'themesflat_customize_register' );

/**
 * Sanitize
 */

// Text
function themesflat_sanitize_text( $input ) {
    return wp_kses_post( force_balance_tags( $input ) );
}

// Background size
function themesflat_sanitize_bg_size( $input ) {
    $valid = array(
        'cover'     => esc_html('Cover', 'specal'),
        'contain'   => esc_html('Contain', 'specal'),
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Blog Layout
function themesflat_sanitize_blog( $input ) {
    $valid = array(
        'sidebar-right'    => esc_html( 'Sidebar right', 'specal' ),
        'sidebar-left'    => esc_html( 'Sidebar left', 'specal' ),
        'fullwidth'  => esc_html( 'Full width (no sidebar)', 'specal' )

    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// themesflat_sanitize_pagination
function themesflat_sanitize_pagination ( $input ) {
    $valid = array(
        'pager' => esc_html__('Pager', 'specal'),
        'numeric' => esc_html__('Numeric', 'specal'),
        'page_numeric' => esc_html__('Pager & Numeric', 'specal')                
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// themesflat_sanitize_pagination
function themesflat_sanitize_layout_version ( $input ) {
    $valid = array(
        'boxed' => esc_html__('Boxed', 'specal'),
        'wide' => esc_html__('Wide', 'specal')          
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// themesflat_sanitize_related_post
function themesflat_sanitize_related_post ( $input ) {
    $valid = array(
        'simple_list' => esc_html__('Simple List', 'specal'),
        'grid' => esc_html__('Grid', 'specal')        
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Footer widget areas
function themesflat_sanitize_fw( $input ) {
    $valid = array(
        '0' => esc_html__('footer_default', 'specal'),
        '1' => esc_html__('One', 'specal'),
        '2' => esc_html__('Two', 'specal'),
        '3' => esc_html__('Three', 'specal'),
        '4' => esc_html__('Four', 'specal')
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Header style sanitize
function themesflat_sanitize_headerstyle( $input ) {
    $valid = themesflat_predefined_header_styles();
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Checkboxes
function themesflat_sanitize_checkbox( $input ) {
    if ( $input == 1 ) {
        return 1;
    } else {
        return '';
    }
}

// Themesflat_sanitize_related_portfolio
function themesflat_sanitize_related_portfolio( $input ) {
    $valid = array(
        'grid'                 => esc_html( 'Grid', 'specal' ),
        'grid_masonry'         => esc_html( 'Grid Masonry', 'specal' ),
        'grid_nomargin'        => esc_html( 'Grid Masonry No Margin', 'specal' ),
        'carosuel'             => esc_html( 'Carosuel', 'specal' ),
        'carosuel_nomargin'    => esc_html( 'Carosuel No Margin', 'specal' )       
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Themesflat_sanitize_portfolio_pagination
function themesflat_sanitize_portfolio_pagination( $input ) {
    $valid = array(
        'page_numeric'         => esc_html( 'Pager & Numeric', 'specal' ),
        'load_more'         => esc_html( 'Load More', 'specal' )     
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Themesflat_sanitize_portfolio_order
function themesflat_sanitize_portfolio_order( $input ) {
    $valid = array(
        'date'          => esc_html( 'Date', 'specal' ),
        'id'            => esc_html( 'Id', 'specal' ),
        'author'        => esc_html( 'Author', 'specal' ),
        'title'         => esc_html( 'Title', 'specal' ),
        'modified'      => esc_html( 'Modified', 'specal' ),
        'comment_count' => esc_html( 'Comment Count', 'specal' ),
        'menu_order'    => esc_html( 'Menu Order', 'specal' )     
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Themesflat_sanitize_portfolio_order_direction
function themesflat_sanitize_portfolio_order_direction( $input ) {
    $valid = array(
        'DESC' => esc_html( 'Descending', 'specal' ),
        'ASC'  => esc_html( 'Assending', 'specal' )       
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Themesflat_sanitize_grid_portfolio
function themesflat_sanitize_grid_portfolio( $input ) {
    $valid = array(
        'portfolio-two-columns'     => esc_html( '2 Columns', 'specal' ),
        'portfolio-three-columns'     => esc_html( '3 Columns', 'specal' ),
        'portfolio-four-columns'     => esc_html( '4 Columns', 'specal' ),
        'portfolio-five-columns'     => esc_html( '5 Columns', 'specal' )
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// themesflat_sanitize_grid_portfolio_related
function themesflat_sanitize_grid_portfolio_related( $input ) {
    $valid = array(
        'portfolio-one-columns'     => esc_html( '1 Columns', 'specal' ),
        'portfolio-two-columns'     => esc_html( '2 Columns', 'specal' ),
        'portfolio-three-columns'    => esc_html( '3 Columns', 'specal' ),
        'portfolio-four-columns'     => esc_html( '4 Columns', 'specal' ),
        'portfolio-five-columns'     => esc_html( '5 Columns', 'specal' )
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// Themesflat_sanitize_grid_post_related
function themesflat_sanitize_grid_post_related( $input ) {
    $valid = array(        
        2     => esc_html( '2 Columns', 'specal' ),
        3   => esc_html( '3 Columns', 'specal' ),
        4    => esc_html( '4 Columns', 'specal' ),     
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

// themesflat_sanitize_layout_product
function themesflat_sanitize_layout_product( $input ) {
    $valid = array(        
        'fullwidth'         => esc_html( 'No Sidebar', 'specal' ),
        'sidebar-right'           => esc_html( 'Sidebar Right', 'specal' ),
        'sidebar-left'         => esc_html( 'Sidebar Left', 'specal' )
    );
    if ( array_key_exists( $input, $valid ) ) {
        return $input;
    } else {
        return '';
    }
}

