<?php
/**
 * Return the default options of the theme
 * 
 * @return  void
 */

function themesflat_customize_default_options2($key) {
	$default = array(		
		'footer_controls' => array('padding-top' => 80,'padding-bottom' => 54),
		'bread_crumb_prefix' =>'',
		'enable_content_left_top' => 1,
		'enable_language_switch' => 1,
		'footer_background_image' => '',
		'breadcrumb_separator' =>  esc_html('>', 'specal'),
		'footer_widget_areas'				=> 4,
		'show_post_navigator' => 0,
		'breadcrumb_prefix' => '',
		'logo_top' => 27,
		'menu_location_primary' => 'primary',
		'site_logo'	=> THEMESFLAT_LINK . 'images/logo.png',
		'site_retina_logo' => THEMESFLAT_LINK . 'images/logo@2x.png',
		'social_links'	=> array ("facebook" => '#', "twitter"=> "#", "google-plus" => "#" , "instagram" => "#" , "skype" => "#"),		
		'socials_link_footer' => 0,
		'page_title_overlay_color' => '#ffffff',
		'page_title_text_color' => '#646a7c',
		'page_title_controls' => array('padding-top' => 75,'padding-bottom' => 42),
		'page_title_border_color' => '#ffffff',
		'page_title_background_image' => '',
		'enable_footer'  => 0,
		'footer1' => 'footer-1',
		'footer2' => 'footer-2',
		'footer3' => 'footer-3',
		'footer4' => 'footer-4',
		'footer_border_color' => '#19181D',
		'enable_social_link_top'  => 1,	
		'enable_social_link_bottom'  => 0,
		'enable_social_link_header'  => 0,	
		'logo_margin_left' 	  => 29,
		'show_page_title'	  => 1,
		'show_page_title_heading'	  => 0,
		'portfolio_show_post_navigator' => 0,
		'top_background_color'	=> '#25232b',
		'topbar_textcolor'	=> '#b2b1b8',
		'mainnav_backgroundcolor'=>'#ffffff',
		'mainnav_color'		=> '#424242',
		'mainnav_hover_color'=>'#1688d3',
		'sub_nav_color'		=>'#ffffff',
		'sub_nav_background'=>'#19181D',
		'border_clor_sub_nav'=>'#232227',
		'sub_nav_background_hover'=>'#ffffff',
		'primary_color'=>'#1688d3',
		'body_text_color'=>'#646a7c',
		'body_background_color'	=> '#ffffff',
		'body_font_name'	=> array(
			'family' => 'Quattrocento Sans',
			'style'  => '400',
			'size'   => '14',
			'line_height'=>'24'
			), 
		'header_style'	=> 'header-style1',		
		'enable_button_header' => 0,
		'headings_font_name'	=> array(
			'family' => 'Quattrocento Sans',
			'style'  => '700'			
			),
		'h1_size' => 36,
		'h2_size' => 30,
		'h3_size' => 26,
		'h4_size' => 24,
		'h5_size' => 22,
		'h6_size' => 20,
		'breadcrumb_enabled' => 1,
		'show_post_paginator' => 0,
		'blog_grid_columns' => 3,
		'blog_archive_exclude' => '',
		'testimonial_rating' => 0,
		'blog_layout' => 'sidebar-left',
		'page_layout' => 'sidebar-left',
		'blog_archive_layout' => 'blog-list',
		'related_post_style'	=> 'blog-grid',
		'blog_sidebar_list'		  => 'blog-sidebar',
		'blog_archive_show_post_meta'	=> 1,
		'blog_archive_content' => 0,
		'blog_show_content' => 1,
		'show_read_more' => 1 ,
		'blog_archive_post_excepts_length' => 57,
		'blog_read_more_text' => 'Read More <i class="fa fa-angle-double-right" aria-hidden="true"></i>',
		'blog_archive_pagination_style' => 'pager-numeric',
		'blog_posts_per_page'	=> 9,
		'blog_order_by'	=> 'date',
		'blog_order_direction' => 'DESC',
		'page_sidebar_list'	=> 'blog-sidebar',
		'menu_font_name'	=> array(
			'family' => 'Quattrocento Sans',
			'style'  => '700',
			'size'   => '14',
			'line_height'=>'80',
			),
		'show_readmore'	  => 1,
		'show_filter_portfolio' => 1,
		'portfolio_style'		=>'grid',
		'grid_columns_portfolio' => 'one-three',
		'portfolio_exclude' =>'',
		'portfolio_archive_pagination_style' => 'pager-numeric',
		'portfolio_grid_columns' => 'one-three',	
		'portfolios_sidebar'		=> 'fullwidth',
		'portfolio_post_perpage'	=> 9,
		'portfolio_order_by'	=> 'date',
		'portfolio_order_direction' => 'DESC',
		'portfolio_category_order' => '',
		'portfolio_single_style'	=> 'right_content',
		'related_portfolio_style' => 'grid',
		'grid_columns_portfolio_related' => 'one-three',
		'number_related_portfolio' => 3,
		'show_related_portfolio' => 0,		
		'enable_custom_topbar'  => 0,
		'enable_page_call_out'	=> 0,
		'text_page_callout'	=> 'You will be always aware of all business and financial news !',
        'text_button_page_callout'	=>	'GET A QUOTE <i class="fa fa-angle-double-right"></i>',
        'link_button_call_out' => '#',
		'topbar_enabled' => 0,
		'header_sticky' => 1,
		'onepage_nav_script' => 0,
		'header_searchbox' => 1,		
		'footer_background_color'	=> '#19181d',
		'footer_text_color'			=> '#b2b1b8',
		'bottom_background_color'	=> '#111014',
		'bottom_text_color'			=> '#646a7c',
		'go_top'					=> 1,
		'layout_version'			=> 'wide',		
		'footer_copyright'			=> '<p>2017 <a href="#">Specal</a>. All rights reserved.</p>',
		'top_content' => '
		<ul class="flat-information mgl2">
			<li class="border-right phone">
				<i class="fa fa-phone" aria-hidden="true">
				<a>215-598-385</a>     
			</li>
			<li class="address">
				<i class="fa fa-map-marker" aria-hidden="true"></i>
				<a href="mailto:someone@example.com?Subject=Hello%20again" target="_top">1341 W Mockingbird, NewYork</a> 
			</li>

		</ul>	
		',
		'header_button' => '<div class="btn-click">
		    <a href="#" class="btn-black">GET A QUOTE</a>
		</div>',
		'show_header_content' => 0,
	);
	return $default[$key];
}

/**
 * Return an array that used to declare options
 * for the page
 * 
 * @return  array
 */
function themesflat_portfolio_options_fields() {
	$options['cover_heading'] = array(
		'type' => 'heading',
		'section' => 'general',
		'title' => esc_html__( 'Portfolio', 'specal' ),
		'description' => esc_html__( 'This is an special option, it allow to set Portfolio informations.', 'specal' )
	);

	$options['port_client'] = array(
		'type'    => 'text',
		'section' => 'general',
		'title' => esc_html__( 'Client', 'specal' ),
		'default' => ''
	);

	$options['port_value'] = array(
		'type'    => 'text',
		'section' => 'general',
		'title' => esc_html__( 'Value', 'specal' ),
		'default' => ''
	);

	$options['gallery_portfolio'] = array(
		'type'    => 'image-control',
		'section' => 'general',
		'title' => esc_html__( 'Images', 'specal' ),
		'default' => ''
	);

	themesflat_prepare_options($options);
	return $options;
}

function themesflat_testimonial_options_fields() {
	$options['cover_heading'] = array(
		'type' => 'heading',
		'section' => 'testimonial_details',
		'title' => esc_html__( 'Testimonial Details', 'specal' ),
	);

	$options['testimonial_subtitle'] = array(
		'type'    => 'text',
		'section' => 'testimonial_details',
		'title' => esc_html__( 'Subtitle', 'specal' ),
		'default' => ''
	);

	$options['testimonial_position'] = array(
		'type'    => 'text',
		'section' => 'testimonial_details',
		'title' => esc_html__( 'Position', 'specal' ),
		'default' => ''
	);

	$options['testimonial_rating'] = array(
		'type'    => 'select',
		'section' => 'testimonial_details',
		'title'   => esc_html__( 'Ratings', 'specal' ),
		'default' => themesflat_get_opt('testimonial_rating'),
		'choices'   => array(
				'5' => esc_html__('5 Stars','specal'),
				'4' => esc_html__('4 Stars','specal'),
				'3' => esc_html__('3 Stars','specal'),
				'2' => esc_html__('2 Stars','specal'),
				'1' => esc_html__('1 Stars','specal'),
				'0' => esc_html__('No Rating','specal')
			)
	);

	$options['testimonial_link'] = array(
		'type'    => 'text',
		'section' => 'testimonial_details',
		'title' => esc_html__( 'Link', 'specal' ),
		'default' => ''
	);

	themesflat_prepare_options($options);
	return $options;
}

function themesflat_post_options_fields() {
	$options['blog_heading'] = array(
		'type' => 'heading',
		'section' => 'blog',
		'title' => esc_html__( 'Dear friends,', 'specal' ),
		'description' => esc_html__( 'Option just view if post format is gallery or video! <br/>Thanks!', 'specal' )
	);

	$options['gallery_images_heading'] = array(
		'type' => 'heading',
		'section' => 'blog',
		'title' => esc_html__( 'Post Format: Gallery .', 'specal' ),
		'description' => esc_html__( '', 'specal' )
	);

	$options['gallery_images'] = array(
		'type'    => 'image-control',
		'section' => 'blog',
		'title' => esc_html__( 'Images', 'specal' ),
		'default' => ''
	);

	$options['video_url_heading'] = array(
		'type' => 'heading',
		'section' => 'blog',
		'title' => esc_html__( 'Post Format: Video ( Embeded video from youtube, vimeo ...).', 'specal' ),
		'description' => esc_html__( '', 'specal' )
	);

	$options['video_url'] = array(
		'type'    => 'textarea',
		'section' => 'blog',
		'title' => esc_html__( 'iframe video link', 'specal' ),
		'default' => ''
	);

	themesflat_prepare_options($options);
	return $options;
}

function themesflat_blog_options_fields() {
	$options['position_field_heading'] = array(
		'type' => 'heading',
		'section' => 'events',
		'title' => esc_html__( 'Events', 'specal' ),
		'description' => esc_html__( 'This is an special option, it allow to set Causes informations.', 'specal' )
	);

	$options['position_field'] = array(
		'type'    => 'text',
		'section' => 'events',
		'title' => esc_html__( 'Position', 'specal' ),
		'default' => ''
	);

	$options['address'] = array(
		'type'    => 'textarea',
		'section' => 'events',
		'title' => esc_html__( 'Address', 'specal' ),
		'default' => ''
	);

	$options['event_time'] = array(
		'type'    => 'datetime',
		'section' => 'events',
		'title' => esc_html__( 'Event date time', 'specal' ),
		'default' => ''
	);

	$options['event_link'] = array(
		'type'    => 'text',
		'section' => 'events',
		'title' => esc_html__( 'Link to join', 'specal' ),
		'default' => ''
	);

	themesflat_prepare_options($options);
	return $options;
}

function themesflat_page_options_fields() {
	global $wp_registered_sidebars;
	$options  = array();
	$sidebars = array();

	// Retrieve all registered sidebars
	foreach( $wp_registered_sidebars as $params )
		$sidebars[$params['id']] = $params['name'];

	/**
	 * General
	 */	
	$options['layout_heading'] = array(
		'type' => 'heading',
		'section' => 'general',
		'title' => esc_html__( 'Layout', 'specal' ),
		'description' => esc_html__( 'Choose between a full or a boxed layout to set how this page layout will look like.', 'specal' )
	);
	
	$options['enable_custom_layout'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Layout', 'specal' ),
		'section' => 'general',
		'children'=> array('layout_version','page_layout','sidebar_default','page_sidebar_list','primary_color'),
		'default' => false
	);

	$options['layout_version'] = array(
		'type'    => 'select',
		'title'   => esc_html__( 'Display Style', 'specal' ),
		'section' => 'general',
		'default' => themesflat_get_opt('layout_version'),
		'choices' => array(
			'wide'  =>  esc_html__( 'Wide', 'specal' ),
			'boxed'  =>  esc_html__( 'Boxed', 'specal' )
		)
	);

	$options['primary_color'] = array(
		'type' => 'color-picker',
		'title'   => esc_html__( 'Page Scheme color', 'specal' ),
		'section' => 'general',
		'default' => themesflat_get_opt('primary_color')
	);

	$options['page_layout'] = array(
		'type'    => 'select',
		'title'   => esc_html__( 'Sidebar Position', 'specal' ),
		'section' => 'general',
		'default' => themesflat_customize_default_options2( 'page_layout' ),
		'choices' => array(
			'fullwidth' => esc_html__( 'No Sidebar', 'specal' ),
			'sidebar-left' => esc_html__( 'Sidebar Left', 'specal' ),
			'sidebar-right' =>  esc_html__( 'Sidebar Right', 'specal' )
		)
	);

	$options['page_sidebar_list'] = array(
		'type'    => 'dropdown-sidebar',
		'title'   => esc_html__( 'Custom Sidebar', 'specal' ),
		'section' => 'general',
		'default' => 'sidebar-page'
		);

	$options['page_title_heading'] = array(
		'type' => 'heading',
		'section' => 'general',
		'title' => esc_html__( 'Page Title', 'specal' ),
	);

	$options['enable_custom_page-title'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Page Title', 'specal' ),
		'section' => 'general',
		'children' => array('show_page_title','page_title_overlay_color','page_title_overlay_color','page_title_background_image','show_page_title_heading'),
		'default' => true
	);

	$options['page_title_background_image'] = array(
		'type' => 'single-image-control',
		'title'   => esc_html__( 'Page Title Background Image', 'specal' ),
		'section' => 'general',
		'default' => themesflat_get_opt('page_title_background_image')
	);

	$options['page_title_overlay_color'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Page Title Overlay Color', 'specal' ),
		'section' => 'general',
		'default' => themesflat_customize_default_options2( 'page_title_overlay_color' )
	);

	$options['show_page_title'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Show Page Title', 'specal' ),
		'section' => 'general',
		'default' => themesflat_get_opt( 'show_page_title' )
	);

	$options['show_page_title_heading'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Show Page Title Heading', 'specal' ),
		'section' => 'general',
		'default' => themesflat_get_opt( 'show_page_title_heading' )
	);	

	$options['page_class_heading'] = array(
		'type' => 'heading',
		'section' => 'general',
		'title' => esc_html__( 'Custom Page Class', 'specal' ),
	);
	
	$options['custom_page_class'] = array(
		'type'    => 'text',
		'section' => 'general',
	);		

	/**
	 * Header
	 */
	$options['topbar_heading'] = array(
		'type' => 'heading',
		'section' => 'header',
		'title' => esc_html__( 'Top Bar', 'specal' ),
		'description' => esc_html__( 'Turn on/off the top bar and change it styles.', 'specal' )
	);

	$options['enable_custom_topbar'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Topbar', 'specal' ),
		'section' => 'header',
		'children' => array('topbar_enabled','top_background_color','topbar_textcolor','top_content','enable_content_left_top','enable_social_link_top','enable_language_switch'),
		'default' => false
	);

	$options['topbar_enabled'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Display Topbar On This Page', 'specal' ),
		'section' => 'header',
		'default' => themesflat_customize_default_options2( 'topbar_enabled' )
	);


	$options['enable_social_link_top'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Social Links Top', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'enable_social_link_top' )
	);

	$options['top_background_color'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Topbar Background', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'top_background_color' )
	);

	$options['topbar_textcolor'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Topbar Text Color', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'topbar_textcolor' )
	);

	$options['top_content'] = array(
		'type'    => 'textarea',
		'title'   => esc_html__( 'Content Left', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'top_content' )
	);

	$options['enable_content_left_top'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Content Left Top', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'enable_content_left_top' )
	);

	$options['enable_language_switch'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Language Switch', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'enable_language_switch' )
	);

	$options['header_style_heading'] = array(
		'type'        => 'heading',
		'section'     => 'header',
		'title'       => esc_html__( 'Custom Header', 'specal' ),
		'description' => esc_html__( 'Change the header style, toggle sticky header feature and turn on/off extra menu icons.', 'specal' )
	);

	$options['enable_custom_header_style'] = array(
		'type'    => 'power',
		'title'   => 'Enable Custom Styles',
		'title'   => esc_html__( 'Enable Custom Header', 'specal' ),
		'section' => 'header',
		'children' => array('header_sticky','header_searchbox','header_show_offcanvas','header_image','header_style','enable_button_header','enable_social_link_header'),
		'default' => false
	);
	
	$options['header_style'] = array(
		'type'    => 'radio-images',
		'title'   => esc_html__( 'Header Style', 'specal' ),
		'section' => 'header',
		'default' => themesflat_customize_default_options2('header_style'),
		'choices' => array (
                'header-style1' => array (
                    'tooltip'   => esc_html( 'Header Style 1','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header1.jpg'
                ) ,
                'header-style2'=>  array (
                    'tooltip'   => esc_html( 'Header Style 2','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header2.jpg'
                ) ,
               'header-style3'=>  array(
                    'tooltip'   => esc_html( 'Header Style 3','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header3.jpg'
                ) ,
               'header-style4'=>  array(
                    'tooltip'   => esc_html( 'Header Style 4','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header4.jpg'
                ) ,
                'header-style5'=>  array(
                    'tooltip'   => esc_html( 'Header Style 5','specal' ),
                    'src'       => THEMESFLAT_LINK . 'images/controls/header5.jpg'
                ) ,
        	)
	);

	

	$options['header_sticky'] = array(
		'type'    => 'power',
		'section' => 'header',
		'title'   => esc_html__( 'Enable Sticky Header', 'specal' )
	);

	$options['header_searchbox'] = array(
		'type'    => 'power',
		'section' => 'header',
		'title'   => esc_html__( 'Show Search Menu', 'specal' ),
		'default' => ( 'header_searchbox' )
	);

	$options['enable_button_header'] = array(
		'type'    => 'power',
		'section' => 'header',
		'title'   => esc_html__( 'Enable Button Header', 'specal' ),
		'default' => ( 'enable_button_header' )
	);

	$options['enable_social_link_header'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Social Links Header', 'specal' ),
		'section' => 'header',
		'default' => themesflat_customize_default_options2( 'enable_social_link_header' )
	);

	$options['navigator_heading'] = array(
		'type'        => 'heading',
		'section'     => 'header',
		'title'       => esc_html__( 'Navigator', 'specal' ),
		'description' => esc_html__( 'Just select your menu that you wish assign it to the location on the theme.', 'specal' )
	);

	$options['enable_custom_navigator'] = array(
		'type'    => 'power',
		'section' => 'header',
		'title'   => esc_html__( 'Enable Custom Navigator', 'specal' ),
		'children' => array('onepage_nav_script','mainnav_color','mainnav_backgroundcolor','menu_location_primary'),
		'default' => false
	);

	$options['mainnav_backgroundcolor'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Mainnav Background', 'specal' ),
		'section' => 'header',
		'default' => themesflat_customize_default_options2( 'mainnav_backgroundcolor' )
	);

	$options['mainnav_color'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Mainnav Color', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'mainnav_color' )
	);

	$options['onepage_nav_script'] = array(
		'type'    => 'power',
		'section' => 'header',
		'title'   => esc_html__( 'Enable One Page', 'specal' )
	);

	// Navigator
	$menus     = wp_get_nav_menus();
	if ( $menus ) {
		$choices = array( 0 => esc_html__( '-- Select --', 'specal' ) );
		foreach ( $menus as $menu ) {
			$choices[ $menu->term_id ] = wp_html_excerpt( $menu->name, 40, '&hellip;' );
		}

		$options["menu_location_primary"] = array(
				'title'   => esc_html__('Choose menu for page','specal'),
				'section' => 'header',
				'type' 	  => 'select',
				'choices' => $choices,
				'default' => themesflat_customize_default_options2('menu_location_primary')
			);
	}

	/**
	 * Footer
	 */	
	$options['footer_widgets_heading'] = array(
		'type'        => 'heading',
		'section'     => 'footer',
		'title'       => esc_html__( 'Footer Widgets', 'specal' ),
		'description' => esc_html__( 'This section allow to change the layout and styles of footer widgets to match as you need.', 'specal' )
	);

	$options['enable_custom_footer_widgets'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Footer Widgets', 'specal' ),
		'section' => 'footer',
		'children'=> array('footer_widget_areas','footer1','footer2','footer3','footer4'),
		'default' => false
	);
	
	$options['footer_widget_areas'] = array(
		'type'    => 'select',
		'title'   => esc_html__( 'Footer Widget Layout', 'specal' ),
		'section' => 'footer',
		'choices'   => array(                
                0    => esc_html( 'None', 'specal' ),
                1     => esc_html( '1 Columns', 'specal' ),
                2     => esc_html( '2 Columns', 'specal' ),
                3     => esc_html( '3 Columns', 'specal' ),
                4     => esc_html( '4 Columns', 'specal' ),                
                5     => esc_html( '4 Columns Equals', 'specal' ),                
            ),
		'default' => themesflat_customize_default_options2('footer_widget_areas')
	);

	$options['footer1'] = array(
		'type'    => 'dropdown-sidebar',
		'title'   => esc_html__( 'Footer Widget Area 1', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_customize_default_options2('footer1')
	);

	$options['footer2'] = array(
		'type'    => 'dropdown-sidebar',
		'title'   => esc_html__( 'Footer Widget Area 2', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_customize_default_options2('footer2')
	);

	$options['footer3'] = array(
		'type'    => 'dropdown-sidebar',
		'title'   => esc_html__( 'Footer Widget Area 3', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_customize_default_options2('footer3')
	);

	$options['footer4'] = array(
		'type'    => 'dropdown-sidebar',
		'title'   => esc_html__( 'Footer Widget Area 4', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_customize_default_options2('footer4')
	);

	
	
	$options['footer_heading'] = array(
		'type'        => 'heading',
		'class'       => 'no-border',
		'section'     => 'footer',
		'title'       => esc_html__( 'Custom Footer', 'specal' ),
		'description' => esc_html__( 'You can change the copyright text, show/hide the social icons on the footer.', 'specal' )
	);

	$options['enable_page_call_out'] = array(
		'type'    => 'power',
		'section' => 'footer',
		'title'   => esc_html__( 'Show Page Call Out', 'specal' ),
		'default' => themesflat_customize_default_options2('enable_page_call_out')
	);

	$options['enable_footer'] = array(
		'type'    => 'power',
		'section' => 'footer',
		'title'   => esc_html__( 'Show Footer', 'specal' ),
		'default' => themesflat_get_opt('enable_footer')
	);

	$options['enable_custom_footer'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Footer Content', 'specal' ),
		'section' => 'footer',
		'children'=>array('socials_link_footer','footer_copyright','bottom_text_color','bottom_background_color','footer_background_color','footer_background_image','footer_text_color'),
		'default' => false
	);	

	$options['enable_social_link_bottom'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Social Links Bottom', 'specal' ),
		'section' => 'header',
		'default' => themesflat_get_opt( 'enable_social_link_bottom' )
	);
		
	
	$options['footer_background_color'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Footer Color Background/Overlay', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_get_opt( 'footer_background_color' )
	);

	
	$options['footer_background_image'] = array(
		'type' => 'single-image-control',
		'title'   => esc_html__( 'Footer Background Image', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_get_opt('footer_background_image')
	);

	
	$options['footer_text_color'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Footer Top Text Color', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_get_opt( 'footer_text_color' )
	);

	$options['bottom_background_color'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Bottom Background Color', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_get_opt( 'bottom_background_color' )
	);

	$options['bottom_text_color'] = array(
		'type'    => 'color-picker',
		'title'   => esc_html__( 'Bottom Text Color', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_get_opt( 'bottom_text_color' )
	);

	$options['footer_copyright'] = array(
		'type'    => 'textarea',
		'title'   => esc_html__( 'Copyright', 'specal' ),
		'section' => 'footer',
		'default' => themesflat_get_opt( 'footer_copyright' )
	);

	/**
	 * Portfolio
	 */
	$options['portfolio_list_heading'] = array(
		'type'        => 'heading',
		'class'       => 'no-border',
		'section'     => 'portfolio',
		'title'       => esc_html__( 'Portfolio', 'specal' ),
		'description' => esc_html__( 'Change options in this section to custom style for portfolio listing page.', 'specal' )
	);

	$options['enable_custom_portfolio'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Portfolio layout', 'specal' ),
		'section' => 'portfolio',
		'children'=> array('portfolio_grid_columns','show_filter_portfolio','portfolio_archive_pagination_style','portfolio_post_perpage','portfolio_order_by','portfolio_order_direction','portfolio_pagination_style','portfolio_style','portfolio_exclude','portfolio_category_order'),		
		'default' => false
	);

	$options['portfolio_grid_columns'] = array(
		'type'    => 'select',
		'section' => 'portfolio',
		'title'   => esc_html__( 'Grid Columns', 'specal' ),
		'default' => themesflat_get_opt('portfolio_grid_columns'),
		'choices'   => array(
			'one-half'     => esc_html( '2 Columns', 'specal' ),
			'one-three'     => esc_html( '3 Columns', 'specal' ),
			'one-four'     => esc_html( '4 Columns', 'specal' ),
			'one-five'     => esc_html( '5 Columns', 'specal' )
			)
	);

	$options['show_filter_portfolio'] = array(
		'type'    => 'power',
		'section' => 'portfolio',
		'title'   => esc_html__( 'Show Filter', 'specal' ),
		'default' => themesflat_get_opt('show_filter_portfolio')
	);	

	$options['portfolio_category_order'] = array(
		'type'     => 'text',
		'section'  => 'portfolio',
		'title'    => esc_html__( 'Show these portfolios filter by categories and categories order.(Enter slug)EX:advanced-analytics,corporate-finance. Leave empty for auto load', 'specal' ),
		'default'  => themesflat_get_opt( 'portfolio_category_order' )
	);

	$options['portfolio_style'] = array(
		'type'    => 'select',
		'title'   => esc_html__( 'Portfolio Style', 'specal' ),
		'section' => 'portfolio',
		'default' => 'grid',
		'choices'   => array(
			'grid'           => esc_html( 'Grid', 'specal' ),
			'no-margin'         =>   esc_html( 'Grid No Margin', 'specal' ) ,
			)
	);

	$options['portfolio_exclude'] = array(
		'type'     => 'text',
		'section'  => 'portfolio',
		'title'    => esc_html__( 'Not Show these portfolios by IDs EX:1,2,3', 'specal' ),
		'default'  => themesflat_get_opt( 'portfolio_exclude' )
	);

	$options['portfolio_post_perpage'] = array(
		'type'     => 'spinner',
		'section'  => 'portfolio',
		'title'    => esc_html__( 'Posts Per Page', 'specal' ),
		'default'  => themesflat_get_opt( 'portfolio_post_perpage' )
	);

	$options['portfolio_archive_pagination_style'] = array(
		'type'    => 'select',
		'title'   => esc_html__( 'Pagination Style', 'specal' ),
		'section' => 'portfolio',
		'default' => 'pager-numeric',
		'choices' => array(			
			'pager-numeric' =>  esc_html__( 'Numeric', 'specal' ),
			'loadmore' => esc_html__( 'Load More', 'specal' )
			)
	);
	
	$options['portfolio_order_by'] = array(
		'type'     => 'select',
		'section'  => 'portfolio',
		'title'    => esc_html__( 'Order By', 'specal' ),
		'default'  => 'date',
		'choices'  => array(
			'date'          => esc_html__( 'Date', 'specal' ),
			'ID'            => esc_html__( 'ID', 'specal' ),
			'author'        => esc_html__( 'Author', 'specal' ),
			'title'         => esc_html__( 'Title', 'specal' ),
			'modified'      => esc_html__( 'Modified', 'specal' ),
			'rand'          => esc_html__( 'Random', 'specal' ),
			'comment_count' => esc_html__( 'Comment count', 'specal' ),
			'menu_order'    => esc_html__( 'Menu order', 'specal' ),
			)
	);

	$options['portfolio_order_direction'] = array(
		'type'     => 'select',
		'section'  => 'portfolio',
		'title'    => esc_html__( 'Order Direction', 'specal' ),
		'default'  => 'DESC',
		'choices'  => array(
			'ASC'  => esc_html__( 'Ascending', 'specal' ),
			'DESC' => esc_html__( 'Descending', 'specal' )
			)
	);

	/**
	 * Blog Options
	 */
	$options['blog_list_heading'] = array(
		'type'        => 'heading',
		'class'       => 'no-border',
		'section'     => 'blog',
		'title'       => esc_html__( 'Blog', 'specal' ),
		'description' => esc_html__( 'All options in this section will be used to make style for blog page.', 'specal' )
	);

	$options['enable_custom_blog'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Blog layout', 'specal' ),
		'section' => 'blog',
		'children'=> array('blog_grid_columns','blog_archive_post_excepts','blog_archive_post_excepts_length','blog_archive_show_post_meta','blog_archive_content','blog_read_more','blog_read_more_text','blog_posts_per_page','blog_order_by','blog_order_direction','blog_archive_pagination_style','blog_show_content', 'blog_archive_layout','blog_archive_exclude'),		
		'default' => false
	);

	$options['blog_grid_columns'] = array(
		'type'    => 'select',
		'section' => 'blog',
		'title'   => esc_html__( 'Grid Columns', 'specal' ),
		'default' => themesflat_customize_default_options2('blog_grid_columns'),
		'choices' => array(
			2 => esc_html__( '2 Columns', 'specal' ),
			3 => esc_html__( '3 Columns', 'specal' ),
			)
	);	

	$options['blog_archive_layout'] = array(
		'type'    => 'select',
		'title'   => esc_html__( 'Blog Layout', 'specal' ),
		'section' => 'blog',
		'default' => themesflat_customize_default_options2('blog_archive_layout'),
		'choices' => array(
			'blog-list' =>  esc_html( 'Blog List','specal' ),
            'blog-grid'=>   esc_html( 'Blog Grid','specal' ),
			)
	);

	$options['blog_archive_post_excepts_length'] = array(
		'type'    => 'text',
		'title'   => esc_html__( 'Post Excepts Length', 'specal' ),
		'section' => 'blog',
		'default' => themesflat_customize_default_options2('blog_archive_post_excepts_length')
	);

	$options['enable_custom_content_post'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Enable Custom Content Post', 'specal' ),
		'section' => 'blog',
		'default' => false,
		'children' => array ('show_read_more','blog_read_more_text','blog_show_content')
	);

	$options['blog_show_content'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Show Content Post', 'specal' ),
		'section' => 'blog',
		'default' => themesflat_customize_default_options2('blog_show_content'),
	);	

	$options['show_read_more'] = array(
		'type'    => 'power',
		'title'   => esc_html__( 'Show Read More', 'specal' ),
		'section' => 'blog',
		'default' => themesflat_customize_default_options2('show_read_more'),
	);

	$options['blog_read_more_text'] = array(
		'type'    => 'text',
		'title'   => esc_html__( 'Read More Text', 'specal' ),
		'section' => 'blog',
		'default' =>themesflat_get_opt('blog_read_more_text')
	);

	$options['blog_archive_exclude'] = array(
		'type'    => 'text',
		'title'   => esc_html__( 'Post IDs will be inorged. Ex: 1,2,3', 'specal' ),
		'section' => 'blog',
		'default' =>themesflat_customize_default_options2('blog_archive_exclude')
	);

	$options['blog_posts_per_page'] = array(
		'type'     => 'text',
		'section'  => 'blog',
		'title'    => esc_html__( 'Posts Per Page', 'specal' ),
		'default'  => themesflat_customize_default_options2( 'blog_posts_per_page' )
	);

	$options['blog_archive_pagination_style'] = array(
		'type'    => 'select',
		'title'   => esc_html__( 'Pagination Style', 'specal' ),
		'section' => 'blog',
		'default' => themesflat_customize_default_options2('blog_archive_pagination_style'),
		'choices' => array(
			'pager' =>  esc_html__( 'Pager', 'specal' ),
			'numeric' =>  esc_html__( 'Numeric', 'specal' ),
			'pager-numeric' =>  esc_html__( 'Pager & Numeric', 'specal' ),
			'loadmore' =>  esc_html__( 'Load More', 'specal' )
			)
	);
	
	themesflat_prepare_options($options);	
	return $options;
}
function themesflat_prepare_options($options) {
	$flat_data = get_option('flatopts');
	$flatopts = array();
	if(!is_array($flat_data)) $flat_data = array();
	$children = array_map(function ($ar) {if (isset($ar['children'])){ return $ar['children'];}}, $options);
	$children = array_filter($children);
	foreach ($children as $key => $value) {
		if (is_array($value)) {
			foreach ($value as $_key => $_value) {
				$flatopts[$_value] = $key;
			}
		}
		else {
			$flatopts[$value] = $key;
		}
	}
	$flat_data = array_merge($flat_data,$flatopts);
	update_option('flatopts',$flat_data);
}

