<?php
/**
* @package specal
*/
//Output all custom styles for this theme

function themesflat_custom_styles( $custom ) {
	$custom = '';
	
	$logo_top = themesflat_get_opt('logo_top');

	// Logo top
	if ( $logo_top !='' ) {
		$custom .= ".header .logo a { margin-top:" . $logo_top . "px; }"."\n";
	}

	//Footer border color
	$footer_border_color = themesflat_get_opt( 'footer_border_color');
	if ( $footer_border_color !='' ) {
		$custom .= ".footer { border-color:" . esc_attr($footer_border_color) . "; }"."\n";
	}

    $footer_controls = themesflat_decode(themesflat_get_opt('footer_controls'));
    themesflat_render_box_position(".footer",$footer_controls);
    
	$font = themesflat_get_json('body_font_name');

	$font_style = themesflat_font_style($font['style']);

	$body_fonts = $font['family'];

	$body_line_height = $font['line_height'];

	$body_font_weight = $font_style[0];

	$body_font_style = $font_style[1];

	$body_size = $font['size'];		

	$headings_fonts_ = themesflat_get_json('headings_font_name');

	$headings_fonts_family = $headings_fonts_['family'];	

	$headings_style = themesflat_font_style( $headings_fonts_['style'] );

	$headings_font_weight = $headings_style[0];

	$headings_font_style = $headings_style[1];

	$menu_fonts_ = themesflat_get_json('menu_font_name');

	$menu_fonts_family = $menu_fonts_['family'];

	$menu_fonts_size = $menu_fonts_['size'];

	$menu_line_height = $menu_fonts_['line_height'];

	$menu_style = themesflat_font_style( $menu_fonts_['style'] );

	$menu_font_weight = $menu_style[0];

	$menu_font_style = $menu_style[1];	

	// Body font family
	if ( $body_fonts !='' ) {
		$custom .= 'body,button,input,select,textarea,input[type=submit],.bottom .copyright,a,.breadcrumb-trail.breadcrumbs span,.footer .mc4wp-form input.comment-submit, input[type="text"], input[type="password"], input[type="datetime"], input[type="datetime-local"], input[type="date"], input[type="month"], input[type="time"], input[type="week"], input[type="number"], input[type="email"], input[type="url"], input[type="search"], input[type="tel"], input[type="color"] { font-family:"' . $body_fonts . '"; }"."\n';
	}	

	// Body font style
	if ( isset( $body_font_style ) ) {
        $custom .= "body,button,input,select,textarea { font-style:" . $body_font_style . "; }"."\n";        
	}

	// Body font weight
	if ( $body_font_weight !='' ) {
		$custom .= "body,button,input,select,textarea { font-weight:" . $body_font_weight . ";}"."\n";
	}

    // Body font size
    if ( $body_size !=''  ) {
        $custom .= "body,button,input,select,textarea { font-size:" . intval( $body_size ) . "px; }"."\n";    
    }

    // Body line height
    if ( $body_line_height != '' ) {
        $custom .= "body,button,input,select,textarea { line-height:" . intval( $body_line_height ) . "px ; }"."\n";    
    }

	// Headings font family
	if ( $headings_fonts_family !='' ) {
		$custom .= "h1,h2,h3,h5,h6,widget-title { font-family:" . $headings_fonts_family . "!important;}"."\n";

	}

	//Headings font weight
	if ( $headings_font_weight !='' ) {
		$custom .= "h1,h2,h3,h4,h5,h6 { font-weight:" . $headings_font_weight . ";}"."\n";
	}

	// Headings font style
	if ( isset( $headings_font_style )) {
        $custom .= "h1,h2,h3,h4,h5,h6  { font-style:" . $headings_font_style . "; }"."\n";       

	}

	// Menu font family
	if ( $menu_fonts_family != '') {
		$custom .= "#mainnav > ul > li > a, #mainnav ul.sub-menu > li > a { font-family:" . $menu_fonts_family . ";}"."\n";
	}

	// Menu font weight
	if ( $menu_font_weight != '' ) {
		$custom .= "#mainnav > ul > li > a { font-weight:" . $menu_font_weight . ";}"."\n";
	}

	// Menu font style
	if ( isset( $menu_font_style )) {
        $custom .= "#mainnav > ul > li > a  { font-style:" . $menu_font_style . "; }"."\n";   
	}

    // Menu font size
    if ( $menu_fonts_size != '' ) {
        $custom .= "#mainnav ul li a { font-size:" . intval($menu_fonts_size) . "px;}"."\n";
    }

    // Menu line height
    if ( $menu_line_height != '' ) {
        $custom .= "#mainnav > ul > li > a { line-height:" . intval($menu_line_height) . "px;}"."\n";
    }  

	// H1 font size
	if ( $h1_size = themesflat_get_opt( 'h1_size' ) ) {
		$custom .= "h1 { font-size:" . intval($h1_size) . "px; }"."\n";
	}

    // H2 font size
    if ( $h2_size = themesflat_get_opt( 'h2_size' ) ) {
        $custom .= "h2 { font-size:" . intval($h2_size) . "px; }"."\n";
    }

    // H3 font size
    if ( $h3_size = themesflat_get_opt( 'h3_size' ) ) {
        $custom .= "h3 { font-size:" . intval($h3_size) . "px; }"."\n";
    }

    // H4 font size
    if ( $h4_size = themesflat_get_opt( 'h4_size' ) ) {
        $custom .= "h4 { font-size:" . intval($h4_size) . "px; }"."\n";
    }

    // H5 font size
    if ( $h5_size = themesflat_get_opt( 'h5_size' ) ) {
        $custom .= "h5 { font-size:" . intval($h5_size) . "px; }"."\n";
    }

    // H6 font size
    if ( $h6_size = themesflat_get_opt( 'h6_size' ) ) {
        $custom .= "h6 { font-size:" . intval($h6_size) . "px; }"."\n";
    }    	

	// Body color_theme
	$body_text = themesflat_get_opt( 'body_text_color' );

	if ($body_text !='') {
		$custom .= "#Financial_Occult text,#F__x26__O tspan { fill:" . esc_attr( $body_text ) . ";}"."\n";

		$custom .= "body { color:" . esc_attr($body_text) . "}"."\n";

		$custom .= "a,.portfolio-filter li a,.themesflat-portfolio .item .category-post a:hover,ul.iconlist .list-title a,.breadcrumbs span a, .breadcrumbs a,.breadcrumbs span,h1, h2, h3, h4, h5, h6,strong,.testimonial-content blockquote,.testimonial-content .author-info,.sidebar .widget ul li a,.themesflat_counter.style2 .themesflat_counter-content-right,.themesflat_counter.style2 .themesflat_counter-content-left,.title_related_portfolio,.navigation.paging-navigation:not(.loadmore) a:hover, .navigation.paging-navigation .current, .widget_search .search-form input[type=search],.entry-meta ul,.entry-meta ul.meta-right,.entry-footer strong,.widget.widget_archive ul li:before, .widget.widget_categories ul li:before, .widget.widget_recent_entries ul li:before { color:" . esc_attr($body_text) . "}"."\n";

		//border bodycolor
		$custom .= ".owl-theme .owl-dots .owl-dot span,.widget .widget-title:after, .widget .widget-title:before,ul.iconlist li.circle:before { background-color:" . esc_attr($body_text) . "}"."\n";
	}

	// background bodycolor
	$custom .= ".navigation.paging-navigation:not(.loadmore) a:hover, .navigation.paging-navigation:not(.loadmore) .current { border-color:" . esc_attr($body_text) . "}"."\n";

	//customize top_background_color
    if ( themesflat_get_opt ('body_background_color') !='' ) {
		$custom .= "body { background-color:" . esc_attr(themesflat_get_opt ('body_background_color')) ."; } "."\n";
    }

	//customize top_background_color
    if ( themesflat_get_opt ('top_background_color') !='' ) {
		$custom .= ".themesflat-top ,.mltlngg-lang-switch-names li, .mltlngg-lang-switch-names li > ul li { background-color:" . esc_attr(themesflat_get_opt ('top_background_color')) ."; } "."\n";
		$custom .= ".mltlngg-lang-switch-names li, .mltlngg-lang-switch-names li > ul li { border: 1px solid " . esc_attr(themesflat_get_opt ('top_background_color')) ."; } "."\n";
    }

    //page option top_background_color
    if ( themesflat_choose_opt ('top_background_color') !='' ) {
		$custom .= ".themesflat-top, .mltlngg-lang-switch-names li, .mltlngg-lang-switch-names li > ul li { background-color:" . esc_attr(themesflat_choose_opt ('top_background_color')) ."; } "."\n";
    }

    //Top text color customize
    $top_text_color = themesflat_get_opt( 'topbar_textcolor' );
    if ( themesflat_get_opt( 'topbar_textcolor' ) !='' ) {
	    $border_topbar_color = themesflat_hex2rgba($top_text_color,0.2);

    	$custom .= ".themesflat-top .border-left:before, .themesflat-widget-languages:before, .themesflat-top .border-right:after, .flat-information > li:after { background-color: ".esc_attr($top_text_color).";}";

		$custom .= ".themesflat-top,.info-top-right,.themesflat-top a, .themesflat-top .themesflat-socials li a, .flat-information > li:before, .flat-information > li > a, .flat-language .current > a, .mltlngg-lang-switch-names > li > a, .mltlngg-lang-switch-names > li > a:active, .mltlngg-lang-switch-names > li > a:hover { color:" . esc_attr( $top_text_color ) ." ;} "."\n";
    }

    //Top text color page option
    $top_text_color = themesflat_choose_opt( 'topbar_textcolor' );
    if ( themesflat_choose_opt( 'topbar_textcolor' ) !='' ) {
	    $border_topbar_color = themesflat_hex2rgba($top_text_color,0.2);

    	$custom .= ".themesflat-top .border-left:before, .themesflat-widget-languages:before, .themesflat-top .border-right:after, .flat-information > li:after { background-color: ".esc_attr($top_text_color).";}";

		$custom .= ".themesflat-top,.info-top-right,.themesflat-top a, .themesflat-top .themesflat-socials li a, .flat-information > li:before, .flat-information > li > a, .flat-language .current > a, .mltlngg-lang-switch-names > li > a, .mltlngg-lang-switch-names > li > a:active, .mltlngg-lang-switch-names > li > a:hover { color:" . esc_attr( $top_text_color ) ." ;} "."\n";
    }	  

    // Menu Background
	$mainnav_backgroundcolor = themesflat_get_opt( 'mainnav_backgroundcolor');
	if ( $mainnav_backgroundcolor !='' ) {		
		$custom .= ".themesflat_header_wrap.header-style1 .header, .themesflat_header_wrap.header-style2 .header.widget-header .nav.header-style2, .themesflat_header_wrap.header-style3 .header.widget-header .nav.header-style3, .themesflat_header_wrap.header-style4 .header.widget-header .nav.header-style4, .header.widget-header.header-style5.bg-white { background:" . esc_attr( $mainnav_backgroundcolor ) . ";}"."\n";
	} 

	//page Menu Background
	$page_mainnav_backgroundcolor = themesflat_choose_opt( 'mainnav_backgroundcolor');
	if ( $page_mainnav_backgroundcolor !='' ) {		
		$custom .= ".themesflat_header_wrap.header-style1 .header, .themesflat_header_wrap.header-style2 .header.widget-header .nav.header-style2, .themesflat_header_wrap.header-style3 .header.widget-header .nav.header-style3, .themesflat_header_wrap.header-style4 .header.widget-header .nav.header-style4, .header.widget-header.header-style5.bg-white { background:" . esc_attr( $page_mainnav_backgroundcolor ) . ";}"."\n";
	}

	// Menu mainnav a color
	$mainnav_color = themesflat_get_opt( 'mainnav_color');
	if ( $mainnav_color !='' ) {
		$custom .= "#mainnav > ul > li > a, .header.header-style2 .themesflat-socials li a, .header.header-style2 .show-search a, .header.header-style2 #mainnav > ul > li > a, .header.header-style3 .themesflat-socials li a, .header.header-style3 .show-search a, .header.header-style3 #mainnav > ul > li > a, .header.header-style4 .themesflat-socials li a, .header.header-style4 .show-search a, .header.header-style4 #mainnav > ul > li > a, .nav.header-style5 .themesflat-socials li a, .show-search a { color:" . esc_attr( $mainnav_color ) . ";}"."\n";

		$custom .= ".header.header-style3 .show-search:before,.header.header-style2 .show-search:before, .header.header-style3 .show-search:before { background:" . esc_attr( $mainnav_color ) . ";}"."\n";
	}

	// Menu mainnav a color
	$mainnav_color = themesflat_choose_opt( 'mainnav_color');
	if ( $mainnav_color !='' ) {
		$custom .= "#mainnav > ul > li > a, .header.header-style2 .themesflat-socials li a, .header.header-style2 .show-search a, .header.header-style2 #mainnav > ul > li > a, .header.header-style3 .themesflat-socials li a, .header.header-style3 .show-search a, .header.header-style3 #mainnav > ul > li > a, .header.header-style4 .themesflat-socials li a, .header.header-style4 .show-search a, .header.header-style4 #mainnav > ul > li > a, .nav.header-style5 .themesflat-socials li a, .show-search a { color:" . esc_attr( $mainnav_color ) . ";}"."\n";

		$custom .= ".header.header-style3 .show-search:before, .header.header-style2 .show-search:before, .header.header-style3 .show-search:before { background:" . esc_attr( $mainnav_color ) . ";}"."\n";
	}

	// mainnav_hover_color
	$mainnav_hover_color = themesflat_get_opt( 'mainnav_hover_color');

	if ( $mainnav_hover_color !='' ) {
		$custom .= "#mainnav > ul > li > a:hover,#mainnav > ul > li.current-menu-item > a,#mainnav ul.sub-menu > li > a:hover { color:" . esc_attr( $mainnav_hover_color ) . ";}"."\n";
	}

	//Subnav a color
	$sub_nav_color = themesflat_get_opt( 'sub_nav_color');
	if ( $sub_nav_color !='' ) {
		$custom .= "#mainnav ul.sub-menu > li > a { color:" . esc_attr( $sub_nav_color ) . ";}"."\n";
	}

	//Subnav background color
	$sub_nav_background = themesflat_get_opt( 'sub_nav_background');
	if ( $sub_nav_background !='' ) {
		$custom .= "#mainnav ul.sub-menu { background-color:" . esc_attr( $sub_nav_background ) . ";}"."\n";			
	}

	//sub_nav_background_hover
	$sub_nav_background_hover = themesflat_get_opt( 'sub_nav_background_hover');
	if ( $sub_nav_background_hover !='' ) {
		$custom .= "#mainnav ul.sub-menu > li > a:hover { background-color:" . esc_attr($sub_nav_background_hover) . ";}"."\n";
	}

	//border color sub nav
	$border_clor_sub_nav = themesflat_get_opt( 'border_clor_sub_nav');
	if ( $border_clor_sub_nav !='' ) {
		$custom .= "#mainnav ul.sub-menu > li { border-color:" . esc_attr($border_clor_sub_nav) . "!important; border-top: 1px solid; }"."\n";
	}	

	//  Page Title background image
	$page_title_background_image = themesflat_get_opt( 'page_title_background_image');
	if ( $page_title_background_image !='' ) {
		$custom .= ".page-title { background:url(" . esc_attr($page_title_background_image) . ") no-repeat center/cover;}"."\n";
	}

	//  Page Title background image
	$page_title_background_image = themesflat_choose_opt( 'page_title_background_image');
	if ( $page_title_background_image !='' ) {
		$custom .= ".page-title { background:url(" . esc_attr($page_title_background_image) . ") no-repeat center/cover;}"."\n";
	}

	//  Customize Title Opacity
	$page_title_overlay_color = themesflat_get_opt( 'page_title_overlay_color');
	if ( $page_title_overlay_color !='' ) {
		$custom .= ".page-title .overlay { background:" . esc_attr($page_title_overlay_color) . ";}"."\n";
	}

	//  Page Title Opacity
	$page_title_overlay_color = themesflat_choose_opt( 'page_title_overlay_color');
	if ( $page_title_overlay_color !='' ) {
		$custom .= ".page-title .overlay { background:" . esc_attr($page_title_overlay_color) . ";}"."\n";
	}

	//border title border color
	$page_title_border_color = themesflat_get_opt( 'page_title_border_color');
	if ( $page_title_border_color !='' ) {
		$custom .= ".page-title { border-color:" . esc_attr($page_title_border_color) . "; }"."\n";
	}	

	$page_title_controls = themesflat_decode(themesflat_get_opt('page_title_controls'));
    themesflat_render_box_position(".page-title",$page_title_controls);

    //  Page Title Color
	$page_title_text_color = themesflat_get_opt( 'page_title_text_color');
	if ( $page_title_text_color !='' ) {
		$custom .= ".page-title-heading h1 { color:" . esc_attr($page_title_text_color) . ";}"."\n";
	}

	// Footer simple background image
	global $themesflat_mainID;
	$footer_background_image = themesflat_get_opt( 'footer_background_image');
	if ( $footer_background_image !='' ) {
		$custom .= ".footer_background { background:url(" . esc_attr($footer_background_image) . ") no-repeat center/cover;}"."\n";
	}

	$footer_background_image = themesflat_choose_opt( 'footer_background_image');
	if ( $footer_background_image !='' ) {
		$custom .= ".footer_background { background:url(" . esc_attr($footer_background_image) . ") no-repeat center/cover;}"."\n";
	}
		
	// Footer simple background color
	$footer_background_color = themesflat_get_opt( 'footer_background_color');
	if ( $footer_background_color !='' ) {
		$custom .= ".footer_background .overlay { background:" . esc_attr($footer_background_color) . ";}"."\n";
	}

	$page_footer_background_color = themesflat_get_opt( 'footer_background_color');
	if ( $page_footer_background_color !='' ) {
		$custom .= ".footer_background .overlay { background:" . esc_attr($page_footer_background_color) . ";}"."\n";
	}

	// Footer simple text color
	$footer_text_color = themesflat_get_opt( 'footer_text_color');
	if ( $footer_text_color !='' ) {
		$custom .= ".footer a, .footer, .themesflat-before-footer .custom-info > div,.footer-widgets ul li a,.footer-widgets .company-description p, .footer .widget.widget-recent-news h4 a, .footer .widget.widget_nav_menu ul li a, .footer .mc4wp-form input.emailsubscribe, .footer .widget.widget_nav_menu ul li::before, .footer .widget.widget-recent-news .text p::before { color:" . esc_attr($footer_text_color) . ";}"."\n";
	}

	// bottom_background_color
	$bottom_background_color = themesflat_get_opt( 'bottom_background_color');
	if ( $bottom_background_color !='' ) {
		$custom .= ".bottom { background-color:" . esc_attr( $bottom_background_color ) . ";}"."\n";
	}

	// Bottom text color
	$bottom_text_color = themesflat_get_opt( 'bottom_text_color');

	if ( $bottom_text_color !='' ) {
		$custom .= ".bottom .copyright p,.bottom #menu-bottom li a { color:" . esc_attr( $bottom_text_color ) . ";}"."\n";
	}
	$custom .='.white #Financial_Occult text,.white #F__x26__O tspan {
			fill: #fff; }';

	$custom .= 'test_filter_render';

	// Primary color
    $primary_color = themesflat_get_opt( 'primary_color' );    
	if ($primary_color !='') {
		$custom .= "#Financial_Occult text,#F__x26__O tspan, .addthis_inline_share_toolbox .at-resp-share-element .at-share-btn .at-icon:focus, .addthis_inline_share_toolbox .at-resp-share-element .at-share-btn .at-icon:hover { fill:" . esc_attr( $primary_color ) . "!important;}"."\n";		

		$custom .= ".navigation.pager-numeric .pagination span:hover, .navigation.pager-numeric .pagination a:hover, .navigation.pager-numeric.paging-navigation:not(.loadmore) a:hover, .navigation.paging-navigation.numeric .pagination span:hover, .navigation.paging-navigation.numeric .pagination a:hover, .navigation.pager-numeric .pagination span.current, .navigation.numeric .pagination span.current,
		.iconbox .box-header .box-icon span, a:hover, a:focus, .portfolio-filter li a:hover, .portfolio-filter li.active a, .themesflat-portfolio .item .category-post a, .color_theme, .widget ul li a:hover, .footer-widgets ul li a:hover, .footer a:hover, .themesflat-top a:hover, .themesflat-portfolio .portfolio-container.grid2 .title-post a:hover, .themesflat-button.blog-list-small, .show-search a i:hover, .widget.widget_categories ul li a:hover, .breadcrumbs span a:hover, .breadcrumbs a:hover, .comment-list-wrap .comment-reply-link, .portfolio-single .content-portfolio-detail h3, .portfolio-single .content-portfolio-detail ul li:before, .themesflat-list-star li:before, .themesflat-list li:before, .navigation.posts-navigation .nav-links li a .meta-nav, .testimonial-sliders.style3 .author-name a, ul.iconlist .list-title a:hover, .themesflat_iconbox .iconbox-icon .icon span, .top_bar2 .wrap-header-content ul li i, a:hover, a:focus, .breadcrumb-trail.breadcrumbs span, #mainnav > ul > li > a:hover,#mainnav ul.sub-menu > li > a:hover, #mainnav > ul > li.current-menu-item > a, .show-search a:hover ,.footer .flat-information > li:before, .top-search .search-form label:after, article .content-post h2.entry-title a:hover, .blog-shortcode .meta-post .post-comments a:hover, .widget.widget_recent_entries ul li a:hover, .footer .widget.widget-recent-news .text h4 a:hover, .footer .widget.widget_nav_menu ul li a:hover, .footer .widget.widget_nav_menu ul li.current-menu-item > a, .bottom .copyright p a:hover, .bottom .themesflat-socials li a:hover, .themesflat-top .themesflat-socials li a:hover, .header .nav .themesflat-socials li a:hover, .flat-information > li > a:hover, .flat-language .current > a:hover, .breadcrumb-trail.breadcrumbs span a:hover, #mainnav ul.sub-menu > li > a:hover, .entry-meta ul .post-author .author a.url, .blog-archive .content-post h2.entry-title a:hover, .content-post .themesflat-button-container a, .main-post ul.talk-about li::before, .main-post blockquote a, .comment-list .comment_meta .comment_time, .blog-single ul.meta-post li a:hover, section.page-call-out .btn-click a:hover,.portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-title a:hover, .portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-categories a:hover, .owl-theme .owl-controls .owl-nav div.owl-prev:hover:before, .owl-theme .owl-controls .owl-nav div.owl-next:hover:before, .flat-language .current .unstyled li:hover a, .themesflat_imagebox.style1 .themesflat-button, .themesflat_counter, .themesflat_counter a, .testimonial-content .testimonial-author .author-info, .themesflat_imagebox.style2 .themesflat-button, .bt-get-quote a.themesflat-button:hover, .header-style2 .wrap-header-content .header-information .info-icon i, .header-style3 .wrap-header-content .header-information .info-icon i, .header-style4 .wrap-header-content .header-information .info-icon i, .header.header-style2 #mainnav > ul > li > a:hover, .header.header-style3 #mainnav > ul > li > a:hover, .header.header-style4 #mainnav > ul > li > a:hover, .themesflat_iconbox.themesflat_iconbox-style1:hover .iconbox-icon .icon span, .themesflat-team .gallery-link li span i, .themesflat_imagebox.style3 .themesflat-button:hover, .themesflat_price:hover .price-header .price-title a, .portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-link li a:hover i, .page-links a:hover, .page-links a:focus, .page-links > span, .themesflat_imagebox.style1 .imagebox-title a:hover, .themesflat_imagebox.style2 .imagebox-title a:hover, .themesflat_imagebox.style3 .imagebox-title a:hover, .testimonial-sliders.style2 .author-name a:hover, .testimonial-sliders.style3 .author-name a:hover, .testimonial-sliders.style4 .author-name a:hover, .themesflat-socials li a:hover, .entry-footer .social-share-article ul li a:hover, .footer .flat-information > li i
		{ color:" . esc_attr( $primary_color ) . "}"."\n";

		//background
		$custom .= ".info-top-right a.appoinment, .wrap-header-content a.appoinment, button, input[type=button], input[type=reset], input[type=submit], .go-top:hover, .portfolio-filter.filter-2 li a:hover, .portfolio-filter.filter-2 li.active a, .themesflat-button, .featured-post.blog-slider .flex-prev, .featured-post.blog-slider .flex-next, mark, ins, #themesflat-portfolio-carousel ul.flex-direction-nav li a, .flex-direction-nav li a, .navigation.posts-navigation .nav-links li a:after, .title_related_portfolio:after, .navigation.loadmore a:hover, .owl-theme .owl-controls .owl-nav [class*=owl-], .btn-menu:before, .btn-menu:after, .btn-menu span, .themesflat_counter.style2 .themesflat_counter-icon .icon, widget a.appoinment, .themesflat_imagebox .imagebox-image:after, .nav-widget a.appoinment, .owl-theme .owl-dots .owl-dot span, .widget .widget-title:after, .widget .widget-title:before, ul.iconlist li.circle:before, .page-call-out, .go-top, .blog-shortcode article .featured-post, .entry-border .featured-post,  .widget.widget_categories ul li::before, .widget.widget_tag_cloud .tagcloud a:hover, .blog-archive .entry-border .featured-post, .blog-single .entry-footer .tags-links a:hover, .comments-area ol.comment-list article .comment_content .comement_reply a:hover,.portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-link li span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot.active span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot span:hover, .flat-accordion .toggle-title.vc_active h4 a:after, .themesflat_imagebox.style2 .themesflat-button:before, .testimonial-sliders.style2 .testimonial-slider .owl-stage .active:nth-of-type(even) blockquote, .testimonial-sliders.style2 .item:hover blockquote, .bt-get-quote a.themesflat-button, .bt-get-quote a.themesflat-button:hover, .header-style2 .btn-click a, .header-style5 .btn-click a, .themesflat_iconbox.circle-outlined.themesflat_iconbox-style1 .iconbox-icon, .themesflat-hover .item-hover:after, .themesflat-team .gallery-content .gallery-link li a:hover span, .themesflat_imagebox.style3 .themesflat-button, .themesflat_price .themesflat-button:hover, .themesflat_iconbox.top.circle-outlined.themesflat_iconbox-style2:before, .themesflat-portfolio.yes .owl-carousel.owl-theme .owl-controls .owl-nav > div
		{ background-color:" . esc_attr( $primary_color ) . "}"."\n";

		//border
		$custom .= ".loading-effect-2 > span, .loading-effect-2 > span:before, .loading-effect-2 > span:after, textarea:focus, input[type=text]:focus, input[type=password]:focus, input[type=datetime]:focus, input[type=datetime-local]:focus, input[type=date]:focus, input[type=month]:focus, input[type=time]:focus, input[type=week]:focus, input[type=number]:focus, input[type=email]:focus, input[type=url]:focus, input[type=search]:focus, input[type=tel]:focus, input[type=color]:focus, select:focus, .owl-theme .owl-dots .owl-dot.active span, .owl-theme .owl-dots .owl-dot:hover span, .navigation.loadmore a:hover, .widget.widget_tag_cloud .tagcloud a:hover, .blog-single .entry-footer .tags-links a:hover, .comments-area ol.comment-list article .comment_content .comement_reply a:hover, .comment-list .comment_meta .comement_reply a, .comments-area ol.comment-list article .comment_content .comement_reply a, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot.active span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot span:hover, .testimonial-sliders.style2 .owl-theme .owl-dots .owl-dot.active span, .testimonial-sliders.style2 .owl-theme .owl-dots .owl-dot span:hover, .themesflat_iconbox.circle-outlined .iconbox-icon, .themesflat_iconbox.top.circle-outlined.themesflat_iconbox-style2,.themesflat_iconbox.circle-outlined.themesflat_iconbox-style1:hover .iconbox-icon, .themesflat_iconbox.circle:hover .iconbox-icon, .themesflat_iconbox.square:hover .iconbox-icon,.themesflat_iconbox.circle-outlined .iconbox-icon, .footer .mc4wp-form input.emailsubscribe:focus
		{ border-color:" . esc_attr( $primary_color ) . "}"."\n";

		// Preloader color
		$custom .= ".loader { border-left: 1em solid " . esc_attr( $primary_color ) . "}"."\n";

		// Border top color
		$custom .= ".testimonial-sliders.style2 .testimonial-slider .owl-stage .active:nth-of-type(even) blockquote:after, .testimonial-sliders.style2 .item:hover blockquote::after
		{ border-top: 8px solid " . esc_attr( $primary_color ) . "}"."\n";
	}	

	//Page Opt primary_color	
	$page_primary_color = themesflat_choose_opt( 'primary_color' );
    if ( $page_primary_color !='' ) {
    	$custom .= "#Financial_Occult text,#F__x26__O tspan, .addthis_inline_share_toolbox .at-resp-share-element .at-share-btn .at-icon:focus, .addthis_inline_share_toolbox .at-resp-share-element .at-share-btn .at-icon:hover { fill:" . esc_attr( $page_primary_color ) . "!important;}"."\n";

		$custom .= ".navigation.pager-numeric .pagination span:hover, .navigation.pager-numeric .pagination a:hover, .navigation.pager-numeric.paging-navigation:not(.loadmore) a:hover, .navigation.paging-navigation.numeric .pagination span:hover, .navigation.paging-navigation.numeric .pagination a:hover, .navigation.pager-numeric .pagination span.current, .navigation.numeric .pagination span.current,
		.iconbox .box-header .box-icon span, a:hover, a:focus, .portfolio-filter li a:hover, .portfolio-filter li.active a, .themesflat-portfolio .item .category-post a, .color_theme, .widget ul li a:hover, .footer-widgets ul li a:hover, .footer a:hover, .themesflat-top a:hover, .themesflat-portfolio .portfolio-container.grid2 .title-post a:hover, .themesflat-button.blog-list-small, .show-search a i:hover, .widget.widget_categories ul li a:hover, .breadcrumbs span a:hover, .breadcrumbs a:hover, .comment-list-wrap .comment-reply-link, .portfolio-single .content-portfolio-detail h3, .portfolio-single .content-portfolio-detail ul li:before, .themesflat-list-star li:before, .themesflat-list li:before, .navigation.posts-navigation .nav-links li a .meta-nav, .testimonial-sliders.style3 .author-name a, ul.iconlist .list-title a:hover, .themesflat_iconbox .iconbox-icon .icon span, .top_bar2 .wrap-header-content ul li i, a:hover, a:focus, .breadcrumb-trail.breadcrumbs span, #mainnav > ul > li > a:hover, #mainnav ul.sub-menu > li > a:hover, #mainnav > ul > li.current-menu-item > a, .show-search a:hover ,.footer .flat-information > li:before, .top-search .search-form label:after, article .content-post h2.entry-title a:hover, .blog-shortcode .meta-post .post-comments a:hover, .widget.widget_recent_entries ul li a:hover, .footer .widget.widget-recent-news .text h4 a:hover, .footer .widget.widget_nav_menu ul li a:hover, .footer .widget.widget_nav_menu ul li.current-menu-item > a, .bottom .copyright p a:hover, .bottom .themesflat-socials li a:hover, .themesflat-top .themesflat-socials li a:hover, .header .nav .themesflat-socials li a:hover, .flat-information > li > a:hover, .flat-language .current > a:hover, .breadcrumb-trail.breadcrumbs span a:hover, #mainnav ul.sub-menu > li > a:hover, .entry-meta ul .post-author .author a.url, .blog-archive .content-post h2.entry-title a:hover, .content-post .themesflat-button-container a, .main-post ul.talk-about li::before, .main-post blockquote a, .comment-list .comment_meta .comment_time, .blog-single ul.meta-post li a:hover, section.page-call-out .btn-click a:hover,.portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-title a:hover, .portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-categories a:hover, .owl-theme .owl-controls .owl-nav div.owl-prev:hover:before, .owl-theme .owl-controls .owl-nav div.owl-next:hover:before, .flat-language .current .unstyled li:hover a, .themesflat_imagebox.style1 .themesflat-button, .themesflat_counter, .themesflat_counter a, .testimonial-content .testimonial-author .author-info, .themesflat_imagebox.style2 .themesflat-button, .bt-get-quote a.themesflat-button:hover, .header-style2 .wrap-header-content .header-information .info-icon i, .header-style3 .wrap-header-content .header-information .info-icon i, .header-style4 .wrap-header-content .header-information .info-icon i, .header.header-style2 #mainnav > ul > li > a:hover, .header.header-style3 #mainnav > ul > li > a:hover, .header.header-style4 #mainnav > ul > li > a:hover, .themesflat_iconbox.themesflat_iconbox-style1:hover .iconbox-icon .icon span, .themesflat-team .gallery-link li span i, .themesflat_imagebox.style3 .themesflat-button:hover, .themesflat_price:hover .price-header .price-title a, .portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-link li a:hover i, .page-links a:hover, .page-links a:focus, .page-links > span, .themesflat_imagebox.style1 .imagebox-title a:hover, .themesflat_imagebox.style2 .imagebox-title a:hover, .themesflat_imagebox.style3 .imagebox-title a:hover, .testimonial-sliders.style1 .author-name a:hover, .testimonial-sliders.style2 .author-name a:hover, .testimonial-sliders.style3 .author-name a:hover, .testimonial-sliders.style4 .author-name a:hover, .themesflat-socials li a:hover, .entry-footer .social-share-article ul li a:hover, .footer .flat-information > li i
		{ color:" . esc_attr( $page_primary_color ) ."; } "."\n";

		//background
		$custom .= ".info-top-right a.appoinment, .wrap-header-content a.appoinment, button, input[type=button], input[type=reset], input[type=submit], .go-top:hover, .portfolio-filter.filter-2 li a:hover, .portfolio-filter.filter-2 li.active a, .themesflat-button, .featured-post.blog-slider .flex-prev, .featured-post.blog-slider .flex-next, mark, ins, #themesflat-portfolio-carousel ul.flex-direction-nav li a, .flex-direction-nav li a, .navigation.posts-navigation .nav-links li a:after, .title_related_portfolio:after, .navigation.loadmore a:hover, .owl-theme .owl-controls .owl-nav [class*=owl-], .btn-menu:before, .btn-menu:after, .btn-menu span, .themesflat_counter.style2 .themesflat_counter-icon .icon, widget a.appoinment, .themesflat_imagebox .imagebox-image:after, .nav-widget a.appoinment, .owl-theme .owl-dots .owl-dot span, .widget .widget-title:after, .widget .widget-title:before, ul.iconlist li.circle:before, .page-call-out, .go-top, .blog-shortcode article .featured-post, .entry-border .featured-post,  .widget.widget_categories ul li::before, .widget.widget_tag_cloud .tagcloud a:hover, .blog-archive .entry-border .featured-post, .blog-single .entry-footer .tags-links a:hover, .comments-area ol.comment-list article .comment_content .comement_reply a:hover,.portfolio-container .portfolio-item .portfolio-wrap .portfolio-info .portfolio-link li span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot.active span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot span:hover, .flat-accordion .toggle-title.vc_active h4 a:after, .themesflat_imagebox.style2 .themesflat-button:before, .testimonial-sliders.style2 .testimonial-slider .owl-stage .active:nth-of-type(even) blockquote, .testimonial-sliders.style2 .item:hover blockquote, .bt-get-quote a.themesflat-button, .bt-get-quote a.themesflat-button:hover, .header-style2 .btn-click a, .header-style5 .btn-click a, .themesflat_iconbox.circle-outlined.themesflat_iconbox-style1 .iconbox-icon, .themesflat-hover .item-hover:after, .themesflat-team .gallery-content .gallery-link li a:hover span, .themesflat_imagebox.style3 .themesflat-button, .themesflat_price .themesflat-button:hover, .themesflat_iconbox.top.circle-outlined.themesflat_iconbox-style2:before, .themesflat-portfolio.yes .owl-carousel.owl-theme .owl-controls .owl-nav > div
		{ background-color:" . esc_attr( $page_primary_color ) . "}"."\n";

		//border
		$custom .= ".loading-effect-2 > span, .loading-effect-2 > span:before, .loading-effect-2 > span:after, textarea:focus, input[type=text]:focus, input[type=password]:focus, input[type=datetime]:focus, input[type=datetime-local]:focus, input[type=date]:focus, input[type=month]:focus, input[type=time]:focus, input[type=week]:focus, input[type=number]:focus, input[type=email]:focus, input[type=url]:focus, input[type=search]:focus, input[type=tel]:focus, input[type=color]:focus, select:focus, .owl-theme .owl-dots .owl-dot.active span, .owl-theme .owl-dots .owl-dot:hover span, .navigation.loadmore a:hover, .widget.widget_tag_cloud .tagcloud a:hover, .blog-single .entry-footer .tags-links a:hover, .comments-area ol.comment-list article .comment_content .comement_reply a:hover, .comment-list .comment_meta .comement_reply a, .comments-area ol.comment-list article .comment_content .comement_reply a, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot.active span, .testimonial-sliders.style1 .owl-theme .owl-dots .owl-dot span:hover, .testimonial-sliders.style2 .owl-theme .owl-dots .owl-dot.active span, .testimonial-sliders.style2 .owl-theme .owl-dots .owl-dot span:hover, .themesflat_iconbox.circle-outlined .iconbox-icon, .themesflat_iconbox.top.circle-outlined.themesflat_iconbox-style2,.themesflat_iconbox.circle-outlined.themesflat_iconbox-style1:hover .iconbox-icon, .themesflat_iconbox.circle:hover .iconbox-icon, .themesflat_iconbox.square:hover .iconbox-icon,.themesflat_iconbox.circle-outlined .iconbox-icon, .footer .mc4wp-form input.emailsubscribe:focus
		{ border-color:" . esc_attr( $page_primary_color ) . "}"."\n";

		// Preloader color
		$custom .= ".loader { border-left: 1em solid " . esc_attr( $page_primary_color ) . "}"."\n";

		// Border top color
		$custom .= ".testimonial-sliders.style2 .testimonial-slider .owl-stage .active:nth-of-type(even) blockquote:after, .testimonial-sliders.style2 .item:hover blockquote::after 
		{ border-top: 8px solid " . esc_attr( $page_primary_color ) . "}"."\n";
    }	

	$custom = apply_filters('themesflat/render/style',$custom);
	wp_add_inline_style( 'inline-css', $custom );
}

add_action( 'wp_enqueue_scripts', 'themesflat_custom_styles' );